;==============================================================================
;
;	ACD - Audio CD Player V1.00
;	30.10.1994 Sven B. Schreiber
;	FreeWare - Copyright (c) 1994 Sven B. Schreiber
;	SBS@PARABOL.cl.sub.de
;
;==============================================================================
;
;				  konstanten
;
;==============================================================================
;
DTA		equ	0080h			;datentransferadresse
BASE		equ	0100h			;programmbeginn
;
;------------------------------------------------------------------------------
;
ROWS		equ	25			;anzahl der bildzeilen
COLUMNS		equ	80			;anzahl der bildspalten
MONOCHROME	equ	0B000h			;videosegment monochrom
COLOR		equ	0B800h			;videosegment farbe
;
;------------------------------------------------------------------------------
;
VIDEO		equ	10h			;videosystem
EQUIPMENT	equ	11h			;hardwareausstattung
KBD		equ	16h			;tastatur
DOS		equ	21h			;dos-api
MPX		equ	2Fh			;multiplexer-interrupt
MOUSE		equ	33h			;maus
;
;------------------------------------------------------------------------------
;
DOS_TERMINATE	equ	4Ch			;programm beenden
;
;------------------------------------------------------------------------------
;
KBD_ENTER	equ	01C0Dh			;enter
KBD_ESCAPE	equ	0011Bh			;escape
KBD_UP		equ	04800h			;pfeil aufwrts
KBD_DOWN	equ	05000h			;pfeil abwrts
KBD_INVALID	equ	0FFFFh			;ungltige eingabe
;
;------------------------------------------------------------------------------
;
ASCII_CR	equ	0Dh			;carriage return
;
;------------------------------------------------------------------------------
;
MAX_DEVICES	equ	 26			;maximale anzahl der gerte
MAX_TRACKS	equ	255			;maximale anzahl der spuren
;
;------------------------------------------------------------------------------
;
CC_IOCTL_INPUT			equ	  3
CC_IOCTL_OUTPUT			equ	 12
CC_DEVICE_OPEN			equ	 13
CC_DEVICE_CLOSE			equ	 14
CC_SEEK_SECTOR			equ	131
CC_PLAY_AUDIO			equ	132
CC_STOP_AUDIO			equ	133
CC_RESUME_AUDIO			equ	136
;
;------------------------------------------------------------------------------
;
STATUS_DONE			equ	00000001b
STATUS_BUSY			equ	00000010b
STATUS_ERROR			equ	10000000b
;
;------------------------------------------------------------------------------
;
ERROR_DRIVE_NOT_READY		equ	 2
ERROR_GENERAL_FAILURE		equ	12
ERROR_INVALID_DISK_CHANGE	equ	15
;
;------------------------------------------------------------------------------
;
DEVICE_DOOR_OPEN		equ	0000000000000001b
DEVICE_DOOR_UNLOCKED		equ	0000000000000010b
DEVICE_NO_DISC			equ	0000100000000000b
;
;------------------------------------------------------------------------------
;
II_HEAD_LOCATION		equ	 1
II_DEVICE_STATUS		equ	 6
II_DISK_INFO			equ	10
II_TRACK_INFO			equ	11
II_QCHANNEL_INFO		equ	12
II_UPC_CODE			equ	14
II_STATUS_INFO			equ	15
;
;------------------------------------------------------------------------------
;
IO_RESET_DRIVE			equ	 2
;
;------------------------------------------------------------------------------
;
RAW_MODE			equ	0
COOKED_MODE			equ	1
;
;------------------------------------------------------------------------------
;
DATA_TRACK_MASK			equ	11010000b
DATA_TRACK_ID			equ	01000000b
;
;==============================================================================
;
;				  datentypen
;
;==============================================================================
;
DEVICE_ENTRY		struct
deDeviceSubUnit		BYTE	0		;sub-unit
deDeviceHeaderOffset	WORD	0		;device-header (offset)
deDeviceHeaderSegment	WORD	0		;device-header (segment)
DEVICE_ENTRY		ends
;
SIZE_DEVICE_ENTRY	equ	1+2+2
;
;------------------------------------------------------------------------------
;
TRACK_ENTRY		struct
teTrackNumber		BYTE	0		;spurnummer
teStartingSector	DWORD	0		;erste sektornummer
teNumberOfSectors	DWORD	0		;anzahl der sektoren
TRACK_ENTRY		ends
;
SIZE_TRACK_ENTRY	equ	1+4+4
;
;------------------------------------------------------------------------------
;
REQUEST_HEADER		struct
rhLength		BYTE	0		;anzahl der bytes
rhSubUnit		BYTE	0		;sub-unit
rhCommandCode		BYTE	0		;befehlscode
rhStatus		WORD	0		;status
rhReserved		BYTE	8 dup (0)	;reserviert
REQUEST_HEADER		ends
;
SIZE_REQUEST_HEADER	equ	1+1+1+2+8
;
;------------------------------------------------------------------------------
;
IOCTL_INPUT		struct
iiMediaDescriptor	BYTE	0		;mediadeskriptor-byte
iiTransferAddress	DWORD	0		;transferadresse
iiNumberOfBytes		WORD	0		;anzahl der bytes
iiStartingSector	WORD	0		;startsektor
iiVolumeIdPointer	DWORD	0		;disc-kennung falls fehler 0Fh
IOCTL_INPUT		ends
;
SIZE_IOCTL_INPUT	equ	1+4+2+2+4
;
;------------------------------------------------------------------------------
;
IOCTL_OUTPUT		struct
ioMediaDescriptor	BYTE	0		;mediadeskriptor-byte
ioTransferAddress	DWORD	0		;transferadresse
ioNumberOfBytes		WORD	0		;anzahl der bytes
ioStartingSector	WORD	0		;startsektor
ioVolumeIdPointer	DWORD	0		;disc-kennung falls fehler 0Fh
IOCTL_OUTPUT		ends
;
SIZE_IOCTL_OUTPUT	equ	1+4+2+2+4
;
;------------------------------------------------------------------------------
;
SIZE_DEVICE_OPEN	equ	0
;
;------------------------------------------------------------------------------
;
SIZE_DEVICE_CLOSE	equ	0
;
;------------------------------------------------------------------------------
;
SEEK_SECTOR		struct
skAdressingMode		BYTE	0		;adressierungsmodus
skTransferAddress	DWORD	0		;transferadresse
skNumberOfSectors	WORD	0		;anzahl der sektoren
skStartingSector	DWORD	0		;startsektor
SEEK_SECTOR		ends
;
SIZE_SEEK_SECTOR	equ	1+4+2+4
;
;------------------------------------------------------------------------------
;
PLAY_AUDIO		struct
paAdressingMode		BYTE	0		;adressierungsmodus
paStartingSector	DWORD	0		;erste sektornummer
paNumberOfSectors	DWORD	0		;anzahl der sektoren
PLAY_AUDIO		ends
;
SIZE_PLAY_AUDIO		equ	1+4+4
;
;------------------------------------------------------------------------------
;
SIZE_STOP_AUDIO		equ	0
;
;------------------------------------------------------------------------------
;
SIZE_RESUME_AUDIO	equ	0
;
;------------------------------------------------------------------------------
;
	SIZE_REQUEST_EXTENSION	=	0
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_IOCTL_INPUT
	SIZE_REQUEST_EXTENSION	=	SIZE_IOCTL_INPUT
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_IOCTL_OUTPUT
	SIZE_REQUEST_EXTENSION	=	SIZE_IOCTL_OUTPUT
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_DEVICE_OPEN
	SIZE_REQUEST_EXTENSION	=	SIZE_DEVICE_OPEN
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_DEVICE_CLOSE
	SIZE_REQUEST_EXTENSION	=	SIZE_DEVICE_CLOSE
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_SEEK_SECTOR
	SIZE_REQUEST_EXTENSION	=	SIZE_SEEK_SECTOR
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_PLAY_AUDIO
	SIZE_REQUEST_EXTENSION	=	SIZE_PLAY_AUDIO
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_STOP_AUDIO
	SIZE_REQUEST_EXTENSION	=	SIZE_STOP_AUDIO
endif
;
if	SIZE_REQUEST_EXTENSION	lt	SIZE_RESUME_AUDIO
	SIZE_REQUEST_EXTENSION	=	SIZE_RESUME_AUDIO
endif
;
;------------------------------------------------------------------------------
;
HEAD_LOCATION		struct
hlControlBlockCode	BYTE	0		;steuerungsblock-code
hlAddressingMode	BYTE	0		;adressierungsmodus
hlCurrentLocation	DWORD	0		;aktuelle kopfposition
HEAD_LOCATION		ends
;
SIZE_HEAD_LOCATION	equ	1+1+4
;
;------------------------------------------------------------------------------
;
DEVICE_STATUS		struct
dsControlBlockCode	BYTE	0		;steuerungsblock-code
dsDeviceParameters	DWORD	0		;gerteparameter
DEVICE_STATUS		ends
;
SIZE_DEVICE_STATUS	equ	1+4
;
;------------------------------------------------------------------------------
;
DISK_INFO		struct
diControlBlockCode	BYTE	0		;steuerungsblock-code
diLowestTrack		BYTE	0		;erste spurnummer
diHighestTrack		BYTE	0		;letzte spurnummer
diLeadOut		DWORD	0		;anfang der abschluspur
DISK_INFO		ends
;
SIZE_DISK_INFO		equ	1+1+1+4
;
;------------------------------------------------------------------------------
;
TRACK_INFO		struct
tiControlBlockCode	BYTE	0		;steuerungsblock-code
tiTrackNumber		BYTE	0		;spurnummer
tiStartingPoint		DWORD	0		;anfangspunkt
tiControlInfo		BYTE	0		;steuerungsinfo
TRACK_INFO		ends
;
SIZE_TRACK_INFO		equ	1+1+4+1
;
;------------------------------------------------------------------------------
;
QCHANNEL_INFO		struct
qiControlBlockCode	BYTE	0		;steuerungsblock-code
qiControlAdr		BYTE	0		;control/adr-byte
qiTrackNumber		BYTE	0		;spurnummer
qiIndex			BYTE	0		;index
qiTrackMinute		BYTE	0		;spur-minute
qiTrackSecond		BYTE	0		;spur-sekunde
qiTrackFrame		BYTE	0		;spur-frame
qiZero			BYTE	0		;zero
qiDiscMinute		BYTE	0		;disc-minute
qiDiscSecond		BYTE	0		;disc-sekunde
qiDiscFrame		BYTE	0		;disc-frame
QCHANNEL_INFO		ends
;
SIZE_QCHANNEL_INFO		equ	1+1+1+1+1+1+1+1+1+1+1
;
;------------------------------------------------------------------------------
;
UPC_CODE		struct
ucControlBlockCode	BYTE	0		;steuerungsblock-code
ucControlAdr		BYTE	0		;control/adr-byte
ucProductCode		BYTE	7 dup (0)	;upc/ean-code
ucZero			BYTE	0		;zero
ucAFrame		BYTE	0		;aframe
UPC_CODE		ends
;
SIZE_UPC_CODE		equ	1+1+7+1+1
;
;------------------------------------------------------------------------------
;
RESET_DRIVE		struct
rdControlBlockCode	BYTE	0		;steuerungsblock-code
RESET_DRIVE		ends
;
SIZE_RESET_DRIVE	equ	1
;
;------------------------------------------------------------------------------
;
	SIZE_CONTROL_BLOCK	=	0
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_HEAD_LOCATION
	SIZE_CONTROL_BLOCK	=	SIZE_HEAD_LOCATION
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_DEVICE_STATUS
	SIZE_CONTROL_BLOCK	=	SIZE_DEVICE_STATUS
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_DISK_INFO
	SIZE_CONTROL_BLOCK	=	SIZE_DISK_INFO
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_TRACK_INFO
	SIZE_CONTROL_BLOCK	=	SIZE_TRACK_INFO
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_QCHANNEL_INFO
	SIZE_CONTROL_BLOCK	=	SIZE_QCHANNEL_INFO
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_UPC_CODE
	SIZE_CONTROL_BLOCK	=	SIZE_UPC_CODE
endif
;
if	SIZE_CONTROL_BLOCK	lt	SIZE_RESET_DRIVE
	SIZE_CONTROL_BLOCK	=	SIZE_RESET_DRIVE
endif
;
;==============================================================================
;
;				programmbeginn
;
;==============================================================================
;
code	segment
	assume	cs:code, ds:code, es:code, ss:code
	org	BASE
Start:
	jmp	Main
	BYTE	" SBS ACD V1.00 "
;
;==============================================================================
;
;				  codesegment
;
;==============================================================================
;
;	keine Parameter
;
;------------------------------------------------------------------------------
;
Main:
	call	InitializeVideo			;video-reset
	call	GetStartDevice			;startgert ermitteln
	mov	wStartDevice,cx
	mov	si,MainWindow			;hauptfenster anzeigen
	call	DisplayWindow
	mov	si,MouseResetInfo		;maus-reset
	mov	ax,MouseReset
	call	DisplayAction
	call	InitializePlayer		;cd-player-reset
	jb	Main1
	call	MouseOn				;mauszeiger einschalten
	call	Operate				;betrieb
	call	MouseOff			;mauszeiger ausschalten
Main1:
	mov	si,MainWindow			;hauptfenster entfernen
	call	RemoveWindow
	mov	al,0				;programm beenden
	mov	ah,DOS_TERMINATE
	int	DOS
;
;==============================================================================
;
;	<	cx  -  startgert
;
;------------------------------------------------------------------------------
;
GetStartDevice:
	mov	bx,DTA				;kommandozeile adressieren
GetStartDevice1:
	inc	bx				;leerzeichen berspringen
	mov	al,[bx]
	cmp	al,' '
	jz	GetStartDevice1
	cmp	al,ASCII_CR			;ende?
	jz	GetStartDevice2
	mov	cl,al				;angabe '0'..'9'?
	sub	cl,'0'
	jb	GetStartDevice2
	cmp	cl,10
	jb	GetStartDevice3
GetStartDevice2:
	mov	cl,0				;erstes gert verwenden
GetStartDevice3:
	mov	ch,0				;8 -> 16 bit
	ret
;
;==============================================================================
;
;	keine Parameter
;
;------------------------------------------------------------------------------
;
Operate:
	call	DeviceOpen			;gert ffnen
	jb	Operate5			;fehler
Operate1:
	mov	bx,offset PosTrackList		;spurliste lschen
	call	ClearTrackList
	mov	bx,offset PosPlayStatus		;abspielstatus lschen
	call	ClearPlayStatus
	call	WaitForDisc			;auf disc warten
	jb	Operate4			;abbruch
	mov	bx,offset PosTrackList		;spurliste anzeigen
	call	ShowTrackList
	mov	cx,0				;leerlauf starten
Operate2:
	push	cx
	mov	bx,offset PosPlayStatus		;abspielstatus anzeigen
	call	ShowPlayStatus
	pop	cx
	jb	Operate1			;vermutlich disc-wechsel
	jcxz	Operate3			;leerlauf
	mov	al,bDeviceBusy			;abspielen beendet, pause aus?
	or	al,bPauseMode
	jnz	Operate3
	call	PlayTracks			;abspielen starten
	jnb	Operate3
	mov	cx,0				;fehler
Operate3:
	call	ExecuteCommand			;kommando ausfhren
	cmp	ax,KBD_INVALID			;ungltiges kommando?
	jz	Operate2
	cmp	ax,KBD_ESCAPE			;abbrechen?
	jnz	Operate2
Operate4:
	call	StopAudio			;abspielen beenden
	call	DeviceClose			;gert schlieen
Operate5:
	ret
;
;==============================================================================
;
;	<	c  -  gesetzt falls abbruch
;
;------------------------------------------------------------------------------
;
WaitForDisc:
	call	MouseOff
WaitForDisc1:
	call	GetDiscStatus			;disc eingelegt?
	jnb	WaitForDisc4			;ok
	mov	si,WaitForDiscInfo		;info anzeigen
	call	DisplayWindow
WaitForDisc2:
	call	GetDiscStatus			;disc eingelegt?
	jnb	WaitForDisc3			;ok
	call	GetInputData			;eingabedaten lesen
	jz	WaitForDisc2			;keine daten vorhanden
	cmp	ax,KBD_ESCAPE			;abbrechen?
	jnz	WaitForDisc2
	stc					;abbruch
WaitForDisc3:
	pushf
	mov	si,WaitForDiscInfo		;info entfernen
	call	RemoveWindow
	popf
	jb	WaitForDisc5			;abbruch
WaitForDisc4:
	mov	si,GetTrackListInfo		;spurliste laden
	mov	ax,GetTrackList
	call	DisplayAction
	jb	WaitForDisc1			;fehler
	mov	cl,1				;erste spur suchen
	call	SeekTrack
	jb	WaitForDisc1			;fehler
WaitForDisc5:
	pushf
	mov	wLastCommand,KBD_INVALID	;letztes kommando lschen
	mov	bInputBuffer,0			;eingabepuffer lschen
	mov	bPlayInterrupted,0		;unterbrechungsflag lschen
	call	MouseOn
	call	PauseOff			;pause aus
	popf
	ret
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;		ax  -  kommando
;
;------------------------------------------------------------------------------
;
ExecuteCommand:
	mov	wLastCommand,KBD_INVALID	;kommandopuffer lschen
	push	cx
	call	GetInputData			;eingabedaten lesen
	pop	cx
	jz	ExecuteCommand3			;keine daten vorhanden
	mov	si,CommandList			;kommandoliste durchsuchen
	mov	dx,KBD_INVALID
ExecuteCommand1:
	add	si,2+2				;nchster eintrag
	mov	bx,[si-2]			;aktion laden
	cmp	dx,[si-4]			;ende der liste?
	jz	ExecuteCommand2
	cmp	ax,[si-4]			;kommando gefunden?
	jnz	ExecuteCommand1
	mov	wLastCommand,ax			;kommando merken
ExecuteCommand2:
	cmp	bx,0				;aktion definiert?
	jz	ExecuteCommand3
	call	bx				;aktion ausfhren
ExecuteCommand3:
	mov	ax,wLastCommand			;kommando laden
	ret
;
;==============================================================================
;
;	<	al  -  datenbyte (0 falls keine daten)
;		ah  -  scancode  (0 falls keine daten)
;		z   -  gesetzt falls keine daten
;
;------------------------------------------------------------------------------
;
GetInputData:
	mov	ah,1				;tastaturstatus abfragen
	int	KBD
	jz	GetInputData2			;keine tastaturdaten
	mov	ah,0				;tastaturdaten holen
	int	KBD
	cmp	al,'a'
	jb	GetInputData1
	cmp	al,'z'
	ja	GetInputData1
	add	al,'A'-'a'
GetInputData1:
	cmp	al,' '				;scancode bei zeichen lschen
	sbb	bl,bl
	and	ah,bl
	mov	bl,0				;eingabepuffer laden/lschen
	xchg	bl,bInputBuffer
	cmp	al,'0'				;ziffer?
	jb	GetInputData5
	cmp	al,'9'
	ja	GetInputData5
	mov	bInputBuffer,al			;ziffer puffern
	cmp	bl,0				;gepufferte ziffer vorhanden?
	jz	GetInputData4
	mov	ah,bl				;gepufferte ziffer laden
	mov	bInputBuffer,0
	jmp	GetInputData5
GetInputData2:
	call	MouseStatus			;mausstatus abfragen
	cmp	bx,-1				;maus installiert?
	jz	GetInputData4
	xchg	bx,wMouseKeys			;maustasten laden/merken
	xor	bx,wMouseKeys			;tastenstatus gendert?
	jz	GetInputData4
	and	bx,wMouseKeys			;neu gedrckte tasten holen
	test	bx,0001h			;linke taste?
	jz	GetInputData4
	mov	si,ClickList			;click-tabelle auswerten
GetInputData3:
	cmp	word ptr [si],0			;ende der tabelle?
	mov	ax,[si+2]
	jz	GetInputData5
	mov	ax,[si]				;tastencode laden
	mov	bx,[si+2]			;zeile/spalte laden
	mov	dx,[si+4]			;hhe/breite laden
	add	si,2+1+1+1+1
	cmp	cl,bl				;zeile testen
	jb	GetInputData3
	add	bl,dl
	cmp	cl,bl
	jnb	GetInputData3
	cmp	ch,bh				;spalte testen
	jb	GetInputData3
	add	bh,dh
	cmp	ch,bh
	jnb	GetInputData3
	jmp	GetInputData5			;ok
GetInputData4:
	mov	ax,0				;keine daten
GetInputData5:
	cmp	ax,0				;daten vorhanden?
	ret
;
;==============================================================================
;
;			       abspielsteuerung
;
;==============================================================================
;
;	<	c  -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
InitializePlayer:
	mov	bDeviceBusy,0			;abspielstatus lschen
	mov	bCurrentTrack,0
	mov	wNormalTrackTime,-1
	mov	wNormalDiscTime,-1
	mov	wReverseTrackTime,-1
	mov	wReverseDiscTime,-1
	call	GetDeviceList			;gerteliste laden
	jb	InitializePlayer1
	mov	cx,wStartDevice			;gert whlen
	call	SelectDevice
	jb	InitializePlayer1
	call	GetDeviceStatus			;gertestatus abfragen
InitializePlayer1:
	ret
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
PreviousTrack:
	push	cx
	mov	al,bCurrentTrack		;eine spur zurck
	dec	al
	call	BinaryToAscii
	xchg	al,ah
	pop	cx
	jmp	SelectTrack			;spur whlen
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
NextTrack:
	push	cx
	mov	al,bCurrentTrack		;eine spur weiter
	inc	al
	call	BinaryToAscii
	xchg	al,ah
	pop	cx
	jmp	SelectTrack			;spur whlen
;
;==============================================================================
;
;	>	ax  -  kommando
;		cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
SelectTrack:
	mov	bx,ax
	sub	ax,'00'				;ascii -> bcd
	cmp	al,10				;gltige bcd-zahl?
	jnb	SelectTrack1
	cmp	ah,10
	jnb	SelectTrack1
	mov	wLastCommand,bx			;kommando merken
	mov	bl,al				;bcd -> binr
	mov	al,10
	mul	ah
	add	al,bl
	jz	SelectTrack1			;ungltige spurnummer?
	cmp	al,bNumberOfTracks
	ja	SelectTrack1
	mov	cl,al				;spurnummer laden
	mov	ch,MAX_TRACKS			;bis zum ende abspielen
	push	cx
	call	StopAudio			;abspielen beenden
	pop	cx
	push	cx
	call	SeekTrack			;spur suchen
	pop	cx
	mov	bPlayInterrupted,0		;unterbrechungsflag lschen
SelectTrack1:
	ret
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
StartPlay:
	cmp	bPauseMode,0			;pause?
	jz	StartPlay1
	jmp	PausePlay			;pause aus
StartPlay1:
	cmp	bDeviceBusy,0			;abspielen gestoppt?
	mov	cl,1				;disc neu beginnen
	jz	StartPlay2
	mov	cl,bCurrentTrack		;spur neu beginnen
StartPlay2:
	mov	ch,MAX_TRACKS			;bis zum ende abspielen
	push	cx
	call	PauseOff			;pause aus
	call	StopAudio			;abspielen stoppen
	pop	cx
	push	cx
	call	SeekTrack			;spur suchen
	pop	cx
	mov	bPlayInterrupted,0		;unterbrechungsflag lschen
	ret
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
StopPlay:
	mov	al,bDeviceBusy			;abspielen gestoppt, pause aus?
	or	al,bPauseMode
	jnz	StopPlay1
	mov	wLastCommand,KBD_ESCAPE		;programm beenden
	jmp	StopPlay2
StopPlay1:
	call	PauseOff			;pause aus
	call	StopAudio			;abspielen stoppen
	mov	cl,1				;erste spur suchen
	call	SeekTrack
	mov	cx,0				;leerlauf
StopPlay2:
	mov	bPlayInterrupted,0		;unterbrechungsflag lschen
	ret
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
StartStopPlay:
	cmp	bDeviceBusy,0			;abspielen gestoppt?
	jnz	StartStopPlay1
	jmp	StartPlay			;abspielen starten
StartStopPlay1:
	jmp	PausePlay			;abspielen stoppen
;
;==============================================================================
;
;	>	cx  -  spurinfo
;
;	<	cx  -  spurinfo
;
;------------------------------------------------------------------------------
;
PausePlay:
	cmp	bPauseMode,0			;pause?
	jnz	PausePlay1
	push	cx
	call	PauseOn				;pause ein
	call	StopAudio
	pop	cx
	mov	al,bDeviceBusy			;unterbrechungsflag definieren
	mov	bPlayInterrupted,al
	jmp	PausePlay3
PausePlay1:
	push	cx
	call	PauseOff			;pause aus
	pop	cx
	cmp	bPlayInterrupted,0		;abspielen unterbrochen?
	mov	bPlayInterrupted,0		;unterbrechungsflag lschen
	jz	PausePlay2
	push	cx
	call	ResumeAudio			;abspielen fortsetzen
	pop	cx
	jmp	PausePlay3
PausePlay2:
	cmp	cx,0				;leerlauf?
	jnz	PausePlay3
	mov	cl,1				;disc neu beginnen
	mov	ch,MAX_TRACKS			;bis zum ende abspielen
PausePlay3:
	ret
;
;==============================================================================
;
;	keine Parameter
;
;------------------------------------------------------------------------------
;
PauseOn:
	mov	bPauseMode,-1			;pause-modus aktiviert
	mov	bx,offset PosPlayStatus		;pausemodus kenntlich machen
	clc
	jmp	HilitePlayStatus
;
;==============================================================================
;
;	keine Parameter
;
;------------------------------------------------------------------------------
;
PauseOff:
	mov	bPauseMode,0			;pausemodus deaktiviert
	mov	bx,offset PosPlayStatus		;pausemodus kenntlich machen
	stc
	jmp	HilitePlayStatus
;
;==============================================================================
;
;			 high-level-bildschirmanzeige
;	
;==============================================================================
;
;	>	bx  -  positionsliste
;
;------------------------------------------------------------------------------
;
ShowTrackList:
	push	bx
	call	MouseOff			;mauszeiger ausschalten
	mov	ax,word ptr dNumberOfFrames	;gesamtlaufzeit ermitteln
	mov	dx,word ptr dNumberOfFrames+2
	call	FrameToTime
	pop	bx
	push	bx
	mov	dx,[bx]				;gesamtlaufzeit anzeigen
	call	DisplayTime
	pop	bx
	add	bx,2
	mov	dx,[bx]				;zeile/spalte laden
	mov	si,TrackEntries			;spurliste auswerten
	mov	bx,MAX_DISPLAY
	mov	cl,bNumberOfTracks
	mov	ch,0
	jcxz	ShowTrackList2			;keine eintrge
	cmp	cx,bx				;maximalzahl berschritten?
	jna	ShowTrackList1
	mov	cx,bx
ShowTrackList1:
	push	cx
	push	bx
	push	dx
	push	si
	mov	ax,word ptr [si.teNumberOfSectors]	;spurlaufzeit laden
	mov	dx,word ptr [si.teNumberOfSectors+2]
	call	FrameToTime
	pop	si
	pop	dx
	push	dx
	push	si
	mov	cl,[si.teTrackNumber]		;spurnummer laden
	call	DisplayTrackData
	pop	si
	pop	dx
	pop	bx
	pop	cx
	inc	dl				;nchste zeile
	add	si,SIZE_TRACK_ENTRY		;nchster eintrag
	dec	bx
	loop	ShowTrackList1
ShowTrackList2:
	mov	cx,bx				;anzahl verbleibender zeilen
	jcxz	ShowTrackList4			;keine weiteren zeilen
ShowTrackList3:
	push	cx
	push	dx
	mov	si,offset sTrackClear		;zeile lschen
	call	DisplayString
	pop	dx
	pop	cx
	inc	dl				;nchste zeile
	loop	ShowTrackList3
ShowTrackList4:
	jmp	MouseOn				;mauszeiger einschalten
;
;==============================================================================
;
;	>	bx  -  positionsliste
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
ShowPlayStatus:
	push	bx
	call	GetPlayStatus			;abspielstatus abfragen
	pushf
	and	bh,STATUS_BUSY			;busy-bit auswerten
	add	bh,-1
	sbb	bh,bh
	mov	bDeviceBusy,bh			;busy-flag speichern
	popf
	pop	bx
	jb	ShowPlayStatus2			;fehler
	xchg	cl,bCurrentTrack		;status laden/speichern
	xchg	ax,wNormalTrackTime
	xchg	dx,wNormalDiscTime
	xchg	si,wReverseTrackTime
	xchg	di,wReverseDiscTime
	sub	cl,bCurrentTrack		;status gendert?
	sub	ax,wNormalTrackTime
	sub	dx,wNormalDiscTime
	sub	si,wReverseTrackTime
	sub	di,wReverseDiscTime
	mov	ch,0
	or	cx,ax
	or	cx,dx
	or	cx,si
	or	cx,di
	jz	ShowPlayStatus1			;anzeige beibehalten
	push	bx
	call	MouseOff			;mauszeiger ausschalten
	pop	bx
	push	bx
	mov	al,bCurrentTrack		;spurnummer anzeigen
	mov	dx,[bx]
	call	DisplayDecimal
	pop	bx
	add	bx,2
	push	bx
	mov	ax,wNormalTrackTime		;normale spurzeit anzeigen
	mov	dx,[bx]
	call	DisplayTime
	pop	bx
	add	bx,2
	push	bx
	mov	ax,wReverseTrackTime		;inverse spurzeit anzeigen
	mov	dx,[bx]
	call	DisplayTime
	pop	bx
	add	bx,2
	push	bx
	mov	ax,wNormalDiscTime		;normale disczeit anzeigen
	mov	dx,[bx]
	call	DisplayTime
	pop	bx
	add	bx,2
	mov	ax,wReverseDiscTime		;inverse disczeit anzeigen
	mov	dx,[bx]
	call	DisplayTime
	call	MouseOn				;mauszeiger einschalten
ShowPlayStatus1:
	clc					;ok
ShowPlayStatus2:
	ret
;	
;==============================================================================
;
;	>	bx  -  positionsliste
;
;------------------------------------------------------------------------------
;
ClearTrackList:
	mov	bNumberOfTracks,0		;leere spurliste anzeigen
	mov	word ptr dNumberOfFrames,0	;gesamtlaufzeit lschen
	mov	word ptr dNumberOfFrames+2,0
	push	bx
	call	MouseOff			;mauszeiger ausschalten
	pop	bx
	push	bx
	mov	si,offset sTimeClear		;gesamtlaufzeit lschen
	mov	dx,[bx]
	call	DisplayString
	pop	bx
	add	bx,2
	mov	dx,[bx]				;zeile/spalte laden
	mov	cx,MAX_DISPLAY			;anzahl der zeilen laden
ClearTrackList1:
	push	cx
	push	dx
	mov	si,offset sTrackClear		;zeile lschen
	call	DisplayString
	pop	dx
	pop	cx
	inc	dl				;nchste zeile
	loop	ClearTrackList1
	jmp	MouseOn				;mauszeiger einschalten
;
;==============================================================================
;
;	>	bx  -  positionsliste
;
;------------------------------------------------------------------------------
;
ClearPlayStatus:
	mov	bDeviceBusy,0			;abspielstatus lschen
	mov	bCurrentTrack,0
	mov	wNormalTrackTime,-1
	mov	wNormalDiscTime,-1
	mov	wReverseTrackTime,-1
	mov	wReverseDiscTime,-1
	push	bx
	call	MouseOff			;mauszeiger ausschalten
	pop	bx
	push	bx
	mov	si,offset sDecimalClear		;spurnummer lschen
	mov	dx,[bx]
	call	DisplayString
	pop	bx
	add	bx,2
	push	bx
	mov	si,offset sTimeClear		;normale spurzeit lschen
	mov	dx,[bx]
	call	DisplayString
	pop	bx
	add	bx,2
	push	bx
	mov	si,offset sTimeClear		;inverse spurzeit lschen
	mov	dx,[bx]
	call	DisplayString
	pop	bx
	add	bx,2
	push	bx
	mov	si,offset sTimeClear		;normale disczeit lschen
	mov	dx,[bx]
	call	DisplayString
	pop	bx
	add	bx,2
	mov	si,offset sTimeClear		;inverse disczeit lschen
	mov	dx,[bx]
	call	DisplayString
	jmp	MouseOn				;mauszeiger einschalten
;
;==============================================================================
;
;	>	bx  -  positionsliste
;		c   -  hervorhebungsflag
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
HilitePlayStatus:
	sbb	ah,ah				;or-maske erzeugen
	and	ah,00001000b
	mov	al,11110111b			;and-maske erzeugen
	push	ax
	push	bx
	call	MouseOff			;mauszeiger ausschalten
	pop	bx
	pop	ax
	push	ax
	push	bx
	mov	dx,[bx]				;spurnummer bearbeiten
	mov	cl,1
	mov	ch,2
	call	SetFieldAttributes
	pop	bx
	pop	ax
	add	bx,2
	push	ax
	push	bx
	mov	dx,[bx]				;normale spurzeit bearbeiten
	mov	cl,1
	mov	ch,2+1+2
	call	SetFieldAttributes
	pop	bx
	pop	ax
	add	bx,2
	push	ax
	push	bx
	mov	dx,[bx]				;inverse spurzeit bearbeiten
	mov	cl,1
	mov	ch,2+1+2
	call	SetFieldAttributes
	pop	bx
	pop	ax
	add	bx,2
	push	ax
	push	bx
	mov	dx,[bx]				;normale disczeit bearbeiten
	mov	cl,1
	mov	ch,2+1+2
	call	SetFieldAttributes
	pop	bx
	pop	ax
	add	bx,2
	mov	dx,[bx]				;inverse disczeit bearbeiten
	mov	cl,1
	mov	ch,2+1+2
	call	SetFieldAttributes
	jmp	MouseOn				;mauszeiger einschalten
;
;==============================================================================
;
;			  low-level-bildschirmanzeige
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
InitializeVideo:
	int	EQUIPMENT			;hardwareausstattung abfragen
	and	al,30h
	cmp	al,30h
	mov	bx,MONOCHROME			;monochrombildschirm
	jz	InitializeVideo1
	mov	bx,COLOR			;farbbildschirm
InitializeVideo1:
	mov	wVideoSegment,bx		;bildschirmsegment definieren
	mov	wWindowLayer,0			;fensterebene definieren
	ret
;
;==============================================================================
;
;	>	cl  -  spurnummer (binr)
;		ax  -  zeit (bcd)
;		dl  -  zeile
;		dh  -  spalte
;
;------------------------------------------------------------------------------
;
DisplayTrackData:
	push	dx
	mov	di,offset sTrackString		;spurdaten eintragen
	call	WriteTrackData
	pop	dx
	mov	si,offset sTrackString		;spurdaten anzeigen
	jmp	DisplayString
;
;==============================================================================
;
;	>	al  -  binrzahl (0..99)
;		dl  -  zeile
;		dh  -  spalte
;
;------------------------------------------------------------------------------
;
DisplayDecimal:
	push	dx
	mov	di,offset sDecimalString	;zahl eintragen
	call	WriteDecimal
	pop	dx
	mov	si,offset sDecimalString	;zahl anzeigen
	jmp	DisplayString
;
;==============================================================================
;
;	>	ax  -  zeit (bcd)
;		dl  -  zeile
;		dh  -  spalte
;
;------------------------------------------------------------------------------
;
DisplayTime:
	push	dx
	mov	di,offset sTimeString		;zeit eintragen
	call	WriteTime
	pop	dx
	mov	si,offset sTimeString		;zeit anzeigen
	jmp	DisplayString
;
;==============================================================================
;
;	>	si  -  string
;		dl  -  zeile
;		dh  -  spalte
;
;------------------------------------------------------------------------------
;
DisplayString:
	push	es
	mov	es,wVideoSegment		;videosegment adressieren
	mov	al,COLUMNS			;video-offset berechnen
	mul	dl
	add	al,dh
	adc	ah,0
	shl	ax,1
	mov	di,ax
DisplayString1:
	mov	al,[si]				;zeichen laden
	inc	si
	cmp	al,0				;ende?
	jz	DisplayString2
	mov	es:[di],al			;zeichen anzeigen
	add	di,2
	jmp	DisplayString1
DisplayString2:
	pop	es
	ret
;
;==============================================================================
;
;	>	cl  -  spurnummer (binr)
;		ax  -  zeit (bcd)
;		di  -  puffer
;
;------------------------------------------------------------------------------
;
WriteTrackData:
	push	di
	push	ax
	mov	al,cl				;spurnummer eintragen
	call	WriteDecimal
	pop	ax
	pop	di
	add	di,2+3				;laufzeit eintragen
	jmp	WriteTime
;
;==============================================================================
;
;	>	al  -  binrzahl (0..99)
;		di  -  puffer
;
;------------------------------------------------------------------------------
;
WriteDecimal:
	push	di
	call	BinaryToAscii			;binr -> ascii
	pop	di
	mov	[di],ax				;zahl eintragen
	ret
;
;==============================================================================
;
;	>	ax  -  zeit (bcd)
;		di  -  puffer
;
;------------------------------------------------------------------------------
;
WriteTime:
	push	di
	call	BcdToAscii			;bcd -> ascii
	pop	di
	mov	[di],ax				;minuten eintragen
	mov	[di+2+1],dx			;sekunden eintragen
	ret
;
;==============================================================================
;
;	>	al  -  and-maske
;		ah  -  or-maske
;		dl  -  zeile
;		dh  -  spalte
;		cl  -  anzahl der zeilen
;		ch  -  anzahl der spalten
;
;------------------------------------------------------------------------------
;
SetFieldAttributes:
	mov	bx,ax
	push	es
	mov	es,wVideoSegment		;videosegment adressieren
	mov	al,COLUMNS			;video-offset berechnen
	mul	dl
	add	al,dh
	adc	ah,0
	shl	ax,1
	mov	di,ax
SetFieldAttributes1:
	push	di				;feldanfang merken
	push	cx				;feldlnge merken
SetFieldAttributes2:
	and	es:[di+1],bl			;feldzeile lschen
	or	es:[di+1],bh
	add	di,2
	dec	ch
	jnz	SetFieldAttributes2
	pop	cx
	pop	di
	add	di,COLUMNS*2			;nchste feldzeile
	dec	cl
	jnz	SetFieldAttributes1
	pop	es
	ret
;
;==============================================================================
;
;			       fensterverwaltung
;
;==============================================================================
;
;	>	si  -  maske
;		ax  -  aktion
;
;	<	f   -  ergebnis
;
;------------------------------------------------------------------------------
;
DisplayAction:
	push	si
	push	ax
	call	DisplayWindow			;info anzeigen
	pop	ax
	call	ax				;aktion ausfhren
	pop	si
	pushf
	call	RemoveWindow			;info entfernen
	popf
	ret
;
;==============================================================================
;
;	>	si  -  maske
;
;------------------------------------------------------------------------------
;
DisplayWindow:
	push	es
	mov	es,wVideoSegment		;videosegment laden
	mov	al,[si]				;offset berechnen
	mov	ah,COLUMNS
	mul	ah
	add	al,[si+1]
	adc	ah,0
	shl	ax,1
	mov	di,ax
	mov	cx,[si+2]			;zeilen-/spaltenzhler laden
	add	si,4
	mov	al,cl				;hintergrundadresse berechnen
	mul	ch
	add	ax,si
	mov	bx,ax
	mov	dx,bx				;flagadresse merken
	inc	bx				;flag berspringen
DisplayWindow1:
	push	di
	push	cx
DisplayWindow2:
	mov	al,[si]				;zeichen laden
	mov	ah,al				;sonderzeichen?
	and	ah,0F0h
	cmp	ah,0A0h
	jnz	DisplayWindow3
	sub	al,090h				;sonderzeichen konvertieren
DisplayWindow3:
	mov	ah,[bx]				;farben laden
	xchg	bx,dx
	cmp	byte ptr [bx],0			;palette bereits ausgewertet?
	xchg	bx,dx
	jnz	DisplayWindow4
	push	bx
	sub	ah,'a'				;farben aus palette laden
	mov	bl,ah
	mov	bh,0
	add	bx,Palette
	mov	ah,[bx]
	pop	bx
DisplayWindow4:
	xchg	ax,es:[di]			;zeichen austauschen
	mov	[si],al
	mov	[bx],ah
	add	di,2				;nchste spalte
	inc	si
	inc	bx
	dec	ch
	jnz	DisplayWindow2
	pop	cx
	pop	di
	add	di,COLUMNS*2			;nchste zeile
	dec	cl
	jnz	DisplayWindow1
	pop	es
	mov	bx,dx				;farbpalette ausgewertet
	mov	byte ptr [bx],1
	inc	wWindowLayer			;fensterebenen zhlen
	cmp	wWindowLayer,1			;hauptfenster?
	jnz	DisplayWindow5
	mov	bh,0				;cursortyp merken
	mov	ah,3
	int	VIDEO
	mov	wCursorType,cx
	mov	cx,2000h			;cursor lschen
	mov	ah,1
	int	VIDEO
DisplayWindow5:
	ret
;
;==============================================================================
;
;	>	si  -  maske
;
;------------------------------------------------------------------------------
;
RemoveWindow:
	push	es
	mov	es,wVideoSegment		;videosegment laden
	mov	al,[si]				;offset berechnen
	mov	ah,COLUMNS
	mul	ah
	add	al,[si+1]
	adc	ah,0
	shl	ax,1
	mov	di,ax
	mov	cx,[si+2]			;zeilen-/spaltenzhler laden
	add	si,4
	mov	al,cl				;hintergrundadresse berechnen
	mul	ch
	add	ax,si
	mov	bx,ax
	inc	bx				;flag berspringen
RemoveWindow1:
	push	di
	push	cx
RemoveWindow2:
	mov	al,[si]				;zeichen austauschen
	mov	ah,[bx]
	xchg	ax,es:[di]
	mov	[si],al
	mov	[bx],ah
	add	di,2				;nchste spalte
	inc	si
	inc	bx
	dec	ch
	jnz	RemoveWindow2
	pop	cx
	pop	di
	add	di,COLUMNS*2			;nchste zeile
	dec	cl
	jnz	RemoveWindow1
	pop	es
	dec	wWindowLayer			;fensterebenen zhlen
	jnz	RemoveWindow3			;untergeordnetes fenster
	mov	cx,wCursorType			;cursor wieder anzeigen
	mov	ah,1
	int	VIDEO
RemoveWindow3:
	ret
;
;==============================================================================
;
;				 maussteuerung
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
MouseReset:
	push	ds
	mov	ax,0				;zeropage adressieren
	mov	ds,ax
	mov	bx,MOUSE*4			;maustreiber installiert?
	mov	ax,[bx]
	or	ax,[bx+2]
	pop	ds
	jz	MouseReset1
	mov	ax,0				;maus-reset
	int	MOUSE
MouseReset1:
	mov	wMouseType,ax			;maustyp merken
	mov	bMouseFlag,0			;mauscursor ist ausgeschaltet
	call	MouseStatus			;mausstatus abfragen
	mov	wMouseKeys,bx
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
MouseOn:
	cmp	wMouseType,0			;maus installiert?
	jz	MouseOn1
	push	es
	mov	es,wVideoSegment		;zeichen retten
	mov	di,wMouseCursor
	mov	ax,es:[di]
	mov	wMouseData,ax
	mov	bx,Palette+('l'-'a')		;mauscursor anzeigen
	mov	al,''
	and	ah,11110000b
	xor	ah,[bx]
	mov	es:[di],ax
	pop	es
	mov	bMouseFlag,-1			;mauscorsor ist eingeschaltet
MouseOn1:
	ret
;
;==============================================================================
;
;	keine parameter
;
;------------------------------------------------------------------------------
;
MouseOff:
	cmp	wMouseType,0			;maus installiert?
	jz	MouseOff1
	push	es
	mov	es,wVideoSegment		;zeichen wiederherstellen
	mov	di,wMouseCursor
	mov	ax,wMouseData
	mov	es:[di],ax
	pop	es
	mov	bMouseFlag,0			;mauscursor ist ausgeschaltet
MouseOff1:
	ret
;
;==============================================================================
;
;	<	bx  -  tastenstatus (-1 falls maus nicht installiert)
;		cl  -  zeile
;		ch  -  spalte
;
;------------------------------------------------------------------------------
;
MouseStatus:
	mov	bx,-1				;fehlercode laden
	cmp	wMouseType,0			;maus installiert?
	jnz	MouseStatus1
	ret
MouseStatus1:
	mov	ax,3				;mausstatus abfragen
	int	MOUSE
	shr	cx,1				;spalte berechnen
	shr	cx,1
	shr	cx,1
	shr	dx,1				;zeile berechnen
	shr	dx,1
	shr	dx,1
	mov	ch,dl
	xchg	ch,cl
	mov	al,COLUMNS			;adresse berechnen
	mul	cl
	add	al,ch
	adc	ah,0
	shl	ax,1
	cmp	bMouseFlag,0			;mauscursor eingeschaltet?
	jz	MouseStatus2
	cmp	ax,wMouseCursor			;position gendert?
	jz	MouseStatus2
	push	bx
	push	cx
	push	ax
	call	MouseOff			;mauscursor lschen
	pop	ax
	push	ax
	mov	wMouseCursor,ax			;neue position eintragen
	call	MouseOn				;mauscursor anzeigen
	pop	ax
	pop	cx
	pop	bx
MouseStatus2:
	mov	wMouseCursor,ax			;neue position eintragen
	ret
;
;==============================================================================
;
;			       mscdex-interface
;
;==============================================================================
;
; GetDeviceList()
;
;	Diese Routine mu ganz zu Anfang des Programms aufgerufen werden.
;	Sie erstellt eine Gerteliste, die alle fr den Zugriff auf die
;	vorhandenen CD-ROM-Laufwerke notwendigen Daten enthlt. Danach kann
;	mit SelectDevice() ein spezielles Laufwerk gewhlt werden.
;
;	Gendert:  wNumberOfDevices, DeviceDrives, DeviceEntries
;
; SelectDevice()
;
;	Mit dieser Routine lt sich ein CD-ROM-Laufwerk aus der mit
;	GetDeviceList() erstellten Liste whlen. Danach knnen die Routinen,
;	die auf das Laufwerk zugreifen, aufgeruden werden. Die Gerte sind
;	durch eine eine eindeutige, bei Null beginnende laufende Nummer
;	gekennzeichnet.
;
;	Gendert:  wDeviceNumber, wDeviceDrive, bDeviceSubUnit,
;		   wDeviceHeaderOffset, wDeviceHeaderSegment, sDeviceName
;
; GetDiscStatus()
;
;	Mit dieser Routine kann man feststellen, ob sich eine CD im Laufwerk
;	befindet. Sie sollte in einer Schleife aufgerufen werden, bevor andere
;	Routinen, die auf CD-Daten zugreifen, benutzt werden. Hierzu gehren
;	z.B. GetTrackList() und PlayTracks().
;
; GetTrackList()
;
;	Diese Routine initialisiert die Spurliste mit den auf der eingelegten
;	CD vorgefundenen Audio-Daten und berechnet die Gesamtspielzeit der
;	CD. Datenspuren werden ignoriert. Dieser Schritt mu zu Beginn des
;	Programms sowie nach jedem CD-Wechsel erfolgen, bevor PlayTracks()
;	aufgerufen werden darf.
;
;	Gendert:  bNumberOfTracks, dNumberOfFrames, TrackEntries
;
; SeekTrack()
;
;	Diese Routine fhrt den Lesekopf zum Beginn der angegebenen Spur.
;
; PlayTracks()
;
;	Der Aufruf dieser Routine startet die Audio-Wiedergabe der angegebenen
;	Spuren auf Grundlage der mit GetTrackList() angefertigten Spurliste.
;	Falls sich zwischen den Audiospuren auch Datenspuren befinden, sollte
;	PlayTracks() so lange in einer Schleife aufgerufen werden, bis die
;	zurckgelieferten Spurnummern gleich Null sind.
;
; GetPlayStatus()
;
;	Diese Routine liefert die aktuelle Position einer CD, die gerade
;	abgespielt wird. Die Informationen werden aus der absoluten Q-Kanal-
;	Adresse anhand der von GetTrackList() erstellten Spurliste berechnet.
;
;==============================================================================
;
;	<	c  -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetDeviceList:
	mov	ax,1500h			;anzahl der laufwerke abfragen
	mov	bx,0
	call	mscdex
	cmp	bx,1				;mscdex installiert?
	jb	GetDeviceList2
	mov	wNumberOfDevices,bx		;anzahl der laufwerke merken
	mov	ax,150Ch			;mscdex-version abfragen
	mov	bx,0
	call	mscdex
	cmp	bx,1				;< 2.00?
	jb	GetDeviceList2
	cmp	bx,020Ah			;< 2.10?
	jb	GetDeviceList2
	mov	ax,150Dh			;laufwerksliste abfragen
	mov	bx,DeviceDrives
	call	mscdex
	mov	bx,wNumberOfDevices		;anzahl der laufwerke laden
	mov	si,DeviceDrives			;laufwerksliste adressieren
GetDeviceList1:
	mov	cl,[si]				;laufwerksnummer laden
	mov	ch,0
	cmp	cx,MAX_DEVICES			;gltige laufwerksnummer?
	cmc
	jb	GetDeviceList2
	push	bx
	push	si
	mov	ax,150Bh			;laufwerk testen
	mov	bx,0
	call	mscdex
	sub	bx,0ADADh			;mscdex-signatur?
	add	bx,-1
	pop	si
	pop	bx
	jb	GetDeviceList2
	cmp	ax,1				;laufwerk ok?
	jb	GetDeviceList2
	inc	si				;nchstes laufwerk
	dec	bx
	jnz	GetDeviceList1
	mov	ax,1501h			;gerteliste abfragen
	mov	bx,DeviceEntries
	call	mscdex
	clc					;ok
GetDeviceList2:
	ret
;
;==============================================================================
;
;	>	cx  -  logische gertenummer
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
SelectDevice:
	cmp	cx,wNumberOfDevices		;gertenummer testen
	cmc
	jb	SelectDevice2
	mov	wDeviceNumber,cx		;gertenummer merken
	mov	si,DeviceDrives			;laufwerksnummer adressieren
	add	si,cx
	mov	al,[si]				;laufwerksnummer eintragen
	mov	ah,0
	mov	wDeviceDrive,ax
	mov	ax,SIZE_DEVICE_ENTRY		;gerteeintrag adressieren
	mul	cx
	mov	si,DeviceEntries
	add	si,ax
	mov	al,[si.deDeviceSubUnit]		;sub-unit eintragen
	mov	bDeviceSubUnit,al
	mov	ax,[si.deDeviceHeaderOffset]	;device-header eintragen
	mov	dx,[si.deDeviceHeaderSegment]
	mov	wDeviceHeaderOffset,ax
	mov	wDeviceHeaderSegment,dx
	push	es
	mov	es,dx				;device-header adressieren
	mov	si,ax
	add	si,4+2+2+2			;device-namen adressieren
	mov	di,offset sDeviceName		;zielpuffer
	mov	cx,8				;lnge des namens
SelectDevice1:
	mov	al,es:[si]			;device-namen kopieren
	mov	[di],al
	inc	si
	inc	di
	loop	SelectDevice1
	pop	es
	clc					;ok
SelectDevice2:
	ret
;
;==============================================================================
;
;	<	c   -  gesetzt falls keine disc
;
;------------------------------------------------------------------------------
;
GetDiscStatus:
	call	GetDeviceStatus			;gertestatus abfragen
	jb	GetDiscStatus1			;fehler
	and	ax,DEVICE_NO_DISC		;disc eingelegt?
	add	ax,-1
GetDiscStatus1:
	ret
;
;==============================================================================
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetTrackList:
	mov	bNumberOfTracks,0		;anzahl der spuren lschen
	mov	word ptr dNumberOfFrames,0	;sektorakkumulator lschen
	mov	word ptr dNumberOfFrames+2,0
	call	ResetDrive			;laufwerk initialisieren
	jb	GetTrackList8
	call	GetDiscInfo			;disc-info abfragen
	jb	GetTrackList8
	push	cx
	call	RedbookToFrame			;lead-out-position umrechnen
	pop	cx
	push	dx
	push	ax
	mov	di,TrackEntries			;spurliste bearbeiten
GetTrackList1:
	push	di
	push	cx
	call	GetTrackInfo			;spurinfo abfragen
	pop	cx
	pop	di
	jb	GetTrackList7			;fehler
	push	bx
	push	di
	push	cx
	call	RedbookToFrame			;anfangssektor umrechnen
	pop	cx
	pop	di
	pop	bx
	mov	[di.teTrackNumber],cl		;spurnummer merken
	mov	word ptr [di.teStartingSector],ax	;ersten sektor merken
	mov	word ptr [di.teStartingSector+2],dx
	mov	word ptr [di.teNumberOfSectors],-1	;feld noch undefiniert
	mov	word ptr [di.teNumberOfSectors+2],-1
	cmp	di,TrackEntries			;keine eintrge?
	jz	GetTrackList3
	sub	di,SIZE_TRACK_ENTRY		;vorigen eintrag adressieren
	mov	si,word ptr [di.teNumberOfSectors]	;bereits abgeschlossen?
	and	si,word ptr [di.teNumberOfSectors+2]
	inc	si
	jnz	GetTrackList2
	sub	ax,word ptr [di.teStartingSector]	;sektoren zhlen
	sbb	dx,word ptr [di.teStartingSector+2]
	mov	word ptr [di.teNumberOfSectors],ax
	mov	word ptr [di.teNumberOfSectors+2],dx
	add	word ptr dNumberOfFrames,ax		;sektoren akkumulieren
	adc	word ptr dNumberOfFrames+2,dx
GetTrackList2:
	add	di,SIZE_TRACK_ENTRY		;aktuellen eintrag adressieren
GetTrackList3:
	and	bl,DATA_TRACK_MASK		;datenspuren ignorieren
	cmp	bl,DATA_TRACK_ID
	jz	GetTrackList4
	add	di,SIZE_TRACK_ENTRY		;nchster eintrag
GetTrackList4:
	inc	cl				;nchste spur
	cmp	cl,ch				;ende?
	jna	GetTrackList1
	pop	ax				;lead-out-sektornummer laden
	pop	dx
	push	dx
	push	ax
	cmp	di,TrackEntries			;keine eintrge?
	jz	GetTrackList6
	sub	di,SIZE_TRACK_ENTRY		;letzten eintrag adressieren
	mov	si,word ptr [di.teNumberOfSectors]	;bereits abgeschlossen?
	and	si,word ptr [di.teNumberOfSectors+2]
	inc	si
	jnz	GetTrackList5
	sub	ax,word ptr [di.teStartingSector]	;sektoren zhlen
	sbb	dx,word ptr [di.teStartingSector+2]
	mov	word ptr [di.teNumberOfSectors],ax
	mov	word ptr [di.teNumberOfSectors+2],dx
	add	word ptr dNumberOfFrames,ax		;sektoren akkumulieren
	adc	word ptr dNumberOfFrames+2,dx
GetTrackList5:
	add	di,SIZE_TRACK_ENTRY		;listenende adressieren
GetTrackList6:
	sub	di,TrackEntries			;anzahl der spuren berechnen
	mov	ax,di
	mov	cl,SIZE_TRACK_ENTRY
	div	cl
	mov	bNumberOfTracks,al		;anzahl der spuren merken
	clc					;ok
GetTrackList7:
	pop	ax				;stack korrigieren
	pop	dx
GetTrackList8:
	ret
;
;==============================================================================
;
;	>	cl  -  spurnummer
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
SeekTrack:
	cmp	cl,1				;spurnummer zu klein?
	adc	cl,0
	cmp	cl,bNumberOfTracks		;spurnummer zu gro?
	jna	SeekTrack1
	mov	cl,bNumberOfTracks
SeekTrack1:
	sub	cl,1				;keine spuren vorhanden?
	mov	ax,0
	mov	dx,0
	jb	SeekTrack2
	mov	al,SIZE_TRACK_ENTRY		;spureintrag adressieren
	mul	cl
	add	ax,TrackEntries
	mov	bx,ax				;erste sektornummer laden
	mov	ax,word ptr [bx.teStartingSector]
	mov	dx,word ptr [bx.teStartingSector+2]
SeekTrack2:
	jmp	SeekSector			;sektor suchen
;
;==============================================================================
;
;	>	cl  -  erste spur
;		ch  -  letzte spur
;
;	<	cl  -  nchste spur (0 falls fertig)
;		ch  -  letzte spur  (0 falls fertig)
;		c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
PlayTracks:
	cmp	cl,1				;spurnummer zu klein?
	adc	cl,0
	cmp	cl,bNumberOfTracks		;spurnummer zu gro?
	jna	PlayTracks1
	mov	cl,bNumberOfTracks
PlayTracks1:
	cmp	ch,1				;spurnummer zu klein?
	adc	ch,0
	cmp	ch,bNumberOfTracks		;spurnummer zu gro?
	jna	PlayTracks2
	mov	ch,bNumberOfTracks
PlayTracks2:
	clc					;nichts zu tun
	jcxz	PlayTracks7
	push	cx
	dec	cl				;ersten spureintrag adressieren
	mov	al,SIZE_TRACK_ENTRY
	mul	cl
	add	ax,TrackEntries
	mov	bx,ax
	sub	ch,cl				;spurzhler vorbereiten
	mov	cl,ch
	mov	ax,word ptr [bx.teStartingSector]	;ersten sektor laden
	mov	dx,word ptr [bx.teStartingSector+2]
	mov	di,0				;anzahl der sektoren lschen
	mov	si,0
	jmp	PlayTracks4
PlayTracks3:
	inc	ch				;aufeinanderfolgende spuren?
	cmp	ch,[bx.teTrackNumber]
	jnz	PlayTracks5			;job unterteilen
PlayTracks4:
	mov	ch,[bx.teTrackNumber]		;spurnummer merken
	add	di,word ptr [bx.teNumberOfSectors]	;sektoren zhlen
	adc	si,word ptr [bx.teNumberOfSectors+2]
	add	bx,SIZE_TRACK_ENTRY		;nchster eintrag
	dec	cl				;spuren zhlen
	jnz	PlayTracks3
PlayTracks5:
	push	cx
	call	PlayAudio			;spuren abspielen
	pop	cx
	pop	dx
	pushf
	cmp	cl,0				;job beendet?
	mov	ch,0
	jz	PlayTracks6
	xchg	cx,dx
	mov	cl,ch				;nchsten teiljob vorbereiten
	sub	cl,dl
	inc	cl
PlayTracks6:
	popf
PlayTracks7:
	ret
;
;==============================================================================
;
;	<	cl  -  logische spurnummer (0 = ungltig)
;		ch  -  physikalische spurnummer
;		ax  -  zeit innerhalb der spur
;		dx  -  zeit innerhalb der disc
;		si  -  zeit innerhalb der spur (invers)
;		di  -  zeit innerhalb der disc (invers)
;		bx  -  anfragestatus
;		c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetPlayStatus:
	call	GetDiscStatus			;disc eingelegt?
	jb	GetPlayStatus6
	call	GetHeadLocation			;aktuelle position abfragen
	jb	GetPlayStatus6
	push	bx
	call	RedbookToFrame			;discposition umrechnen
	mov	bx,TrackEntries			;spurliste adressieren
	mov	di,0				;sektorzhler lschen
	mov	si,0
	mov	ch,0				;phys. spurnummer lschen
	mov	cl,bNumberOfTracks		;spurzhler laden
	cmp	cl,0				;daten vorhanden?
	jz	GetPlayStatus2
GetPlayStatus1:
	push	dx
	push	ax
	sub	ax,word ptr [bx.teStartingSector]	;adresse berschritten?
	sbb	dx,word ptr [bx.teStartingSector+2]
	pop	ax
	pop	dx
	jb	GetPlayStatus2
	mov	ch,[bx.teTrackNumber]			;phys. spurnummer laden
	add	di,word ptr [bx.teNumberOfSectors]	;sektoren zhlen
	adc	si,word ptr [bx.teNumberOfSectors+2]
	add	bx,SIZE_TRACK_ENTRY
	dec	cl
	jnz	GetPlayStatus1
GetPlayStatus2:
	neg	cl				;logische spurnummer berechnen
	add	cl,bNumberOfTracks
	jnz	GetPlayStatus3
	mov	ax,0				;position vor erster spur
	mov	dx,0
	jmp	GetPlayStatus4
GetPlayStatus3:
	sub	bx,SIZE_TRACK_ENTRY		;eine spur zurck
	sub	ax,word ptr [bx.teStartingSector]	;pos. in spur berechnen
	sbb	dx,word ptr [bx.teStartingSector+2]
	sub	di,word ptr [bx.teNumberOfSectors]	;spuroffset berechnen
	sbb	si,word ptr [bx.teNumberOfSectors+2]
	push	dx
	push	ax
	sub	ax,word ptr [bx.teNumberOfSectors]	;hinter der spur?
	sbb	dx,word ptr [bx.teNumberOfSectors+2]
	pop	ax
	pop	dx
	jb	GetPlayStatus4
	mov	ax,word ptr [bx.teNumberOfSectors]	;position korrigieren
	mov	dx,word ptr [bx.teNumberOfSectors+2]
	mov	cl,0					;ungltige spurnummer
GetPlayStatus4:
	add	di,ax					;pos. in disc berechnen
	adc	si,dx
	push	si
	push	di
	push	dx
	push	ax
	push	bx
	push	cx
	call	FrameToTime			;zeit in der spur berechnen
	mov	di,ax
	pop	cx
	pop	bx
	pop	ax
	pop	dx
	cmp	cl,0
	mov	si,0
	jz	GetPlayStatus5
	not	ax
	not	dx
	add	ax,1
	adc	dx,0
	add	ax,word ptr [bx.teNumberOfSectors]
	adc	dx,word ptr [bx.teNumberOfSectors+2]
	push	di
	push	cx
	call	FrameToTime
	mov	si,ax
	pop	cx
	pop	di
GetPlayStatus5:
	pop	ax
	pop	dx
	push	cx
	push	si
	push	di
	push	dx
	push	ax
	call	FrameToTime			;zeit in der disc berechnen
	mov	di,ax
	pop	ax
	pop	dx
	not	ax
	not	dx
	add	ax,1
	adc	dx,0
	add	ax,word ptr dNumberOfFrames
	adc	dx,word ptr dNumberOfFrames+2
	push	di
	call	FrameToTime
	mov	di,ax
	pop	dx
	pop	ax
	pop	si
	pop	cx
	pop	bx
	clc					;ok
GetPlayStatus6:
	ret
;
;==============================================================================
;
;	<	ax  -  status
;		c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
SendDeviceRequest:
	mov	ax,1510h			;anfrage senden
	mov	bx,RequestHeader
	mov	cx,wDeviceDrive
	mov	dl,bDeviceSubUnit
	mov	[bx.rhSubUnit],dl
	mov	dl,ERROR_GENERAL_FAILURE
	mov	dh,STATUS_ERROR
	mov	[bx.rhStatus],dx
	call	mscdex
	mov	bx,RequestHeader		;status laden
	mov	ax,[bx.rhStatus]
	mov	bh,ah				;fehler?
	and	bh,STATUS_ERROR
	add	bh,-1
	ret
;
;==============================================================================
;
;			       treiber-interface
;
;==============================================================================
;
;	<	bx  -  anfragestatus
;		c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
ResetDrive:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_OUTPUT
	mov	[bx.rhCommandCode],CC_IOCTL_OUTPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.ioNumberOfBytes],SIZE_RESET_DRIVE
	mov	word ptr [bx.ioTransferAddress],ControlBlock
	mov	word ptr [bx.ioTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.rdControlBlockCode],IO_RESET_DRIVE
	call	SendDeviceRequest		;kommando ausfhren
	mov	bx,ax				;anfragestatus laden
	ret
;
;==============================================================================
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
DeviceOpen:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_DEVICE_OPEN
	mov	[bx.rhCommandCode],CC_DEVICE_OPEN
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
DeviceClose:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_DEVICE_CLOSE
	mov	[bx.rhCommandCode],CC_DEVICE_CLOSE
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;	<	dx:ax  -  aktuelle position
;		bx     -  anfragestatus
;		c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetHeadLocation:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_HEAD_LOCATION
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.hlControlBlockCode],II_HEAD_LOCATION
	mov	[bx.hlAddressingMode],COOKED_MODE
	call	SendDeviceRequest		;kommando ausfhren
	mov	cx,ax
	mov	bx,ControlBlock			;ergebnis laden
	mov	ax,word ptr [bx.hlCurrentLocation]
	mov	dx,word ptr [bx.hlCurrentLocation+2]
	mov	bx,cx				;anfragestatus laden
	ret
;
;==============================================================================
;
;	<	dx:ax  -  gertestatus
;		bx     -  anfragestatus
;		c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetDeviceStatus:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_DEVICE_STATUS
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.dsControlBlockCode],II_DEVICE_STATUS
	call	SendDeviceRequest		;kommando ausfhren
	mov	cx,ax
	mov	bx,ControlBlock			;ergebnis laden
	mov	ax,word ptr [bx.dsDeviceParameters]
	mov	dx,word ptr [bx.dsDeviceParameters+2]
	mov	bx,cx				;anfragestatus laden
	ret
;
;==============================================================================
;
;	<	dx:ax  -  lead-out-position (redbook)
;		cl     -  erste spur
;		ch     -  letzte spur
;		c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetDiscInfo:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_DISK_INFO
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.diControlBlockCode],II_DISK_INFO
	call	SendDeviceRequest		;kommando ausfhren
	mov	bx,ControlBlock			;ergebnisse laden
	mov	ax,word ptr [bx.diLeadOut]
	mov	dx,word ptr [bx.diLeadOut+2]
	mov	cl,[bx.diLowestTrack]
	mov	ch,[bx.diHighestTrack]
	ret
;
;==============================================================================
;
;	>	cl     -  spur
;
;	<	dx:ax  -  startposition (redbook)
;		bl     -  steuerungsinfo
;		c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetTrackInfo:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_TRACK_INFO
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.tiControlBlockCode],II_TRACK_INFO
	mov	[bx.tiTrackNumber],cl
	call	SendDeviceRequest		;kommando ausfhren
	mov	bx,ControlBlock			;ergebnisse laden
	mov	ax,word ptr [bx.tiStartingPoint]
	mov	dx,word ptr [bx.tiStartingPoint+2]
	mov	bl,[bx.tiControlInfo]
	ret
;
;==============================================================================
;
;	<	cl     -  spur
;		dx:ax  -  laufzeit innerhalb der disc
;		si:di  -  laufzeit innerhalb der spur
;		bx     -  anfragestatus
;		c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetQChannelInfo:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_QCHANNEL_INFO
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.qiControlBlockCode],II_QCHANNEL_INFO
	call	SendDeviceRequest		;kommando ausfhren
	push	ax
	mov	bx,ControlBlock			;ergebnisse laden
	mov	al,[bx.qiDiscFrame]
	mov	ah,[bx.qiDiscSecond]
	mov	dl,[bx.qiDiscMinute]
	mov	dh,0
	mov	cl,[bx.qiTrackFrame]
	mov	ch,[bx.qiTrackSecond]
	mov	di,cx
	mov	cl,[bx.qiTrackMinute]
	mov	ch,0
	mov	si,cx
	mov	cl,[bx.qiTrackNumber]
	pop	bx				;anfragestatus laden
	ret
;
;==============================================================================
;
;	>	di  -  puffer (14 Bytes)
;
;	<	c   -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
GetUpcCode:
	push	di
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_IOCTL_INPUT
	mov	[bx.rhCommandCode],CC_IOCTL_INPUT
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.iiNumberOfBytes],SIZE_UPC_CODE
	mov	word ptr [bx.iiTransferAddress],ControlBlock
	mov	word ptr [bx.iiTransferAddress+2],ds
	mov	bx,ControlBlock			;control-block vorbereiten
	mov	[bx.ucControlBlockCode],II_UPC_CODE
	call	SendDeviceRequest		;kommando ausfhren
	pop	di
	jb	GetUpcCode2			;fehler
	mov	bx,ControlBlock			;produktcode adressieren
	lea	si,[bx.ucProductCode]
	mov	ch,7				;bytezhler laden
	mov	cl,4				;bitzhler laden
GetUpcCode1:
	mov	al,[si]				;1. ziffer extrahieren
	shr	al,cl
	mov	ah,[si]				;2. ziffer extrahieren
	and	ah,0Fh
	add	ax,'00'				;bcd -> ascii
	mov	[di],ax				;ziffern eintragen
	add	di,2
	inc	si				;nchstes paar
	dec	ch
	jnz	GetUpcCode1
	dec	di				;letzte ziffer ungltig
	clc					;ok
GetUpcCode2:
	mov	byte ptr [di],0			;string beenden
	ret
;
;==============================================================================
;
;	>	dx:ax  -  erste sektornummer
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
SeekSector:
	call	FrameToRedbook			;sektornummer umrechnen
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_SEEK_SECTOR
	mov	[bx.rhCommandCode],CC_SEEK_SECTOR
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.skAdressingMode],COOKED_MODE
	mov	[bx.skNumberOfSectors],0
	mov	word ptr [bx.skTransferAddress],0
	mov	word ptr [bx.skTransferAddress+2],0
	mov	word ptr [bx.skStartingSector],ax
	mov	word ptr [bx.skStartingSector+2],dx
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;	>	dx:ax  -  erste sektornummer
;		si:di  -  anzahl der sektoren
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
PlayAudio:
	push	si
	push	di
	call	FrameToRedbook			;sektornummer umrechnen
	pop	di
	pop	si
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_PLAY_AUDIO
	mov	[bx.rhCommandCode],CC_PLAY_AUDIO
	mov	bx,RequestExtension		;spezifische daten eintragen
	mov	[bx.paAdressingMode],COOKED_MODE
	mov	word ptr [bx.paStartingSector],ax
	mov	word ptr [bx.paStartingSector+2],dx
	mov	word ptr [bx.paNumberOfSectors],di
	mov	word ptr [bx.paNumberOfSectors+2],si
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
StopAudio:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_STOP_AUDIO
	mov	[bx.rhCommandCode],CC_STOP_AUDIO
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;	<	c      -  gesetzt falls fehler
;
;------------------------------------------------------------------------------
;
ResumeAudio:
	mov	bx,RequestHeader		;request-header vorbereiten
	mov	[bx.rhLength],SIZE_REQUEST_HEADER+SIZE_RESUME_AUDIO
	mov	[bx.rhCommandCode],CC_RESUME_AUDIO
	jmp	SendDeviceRequest		;kommando ausfhren
;
;==============================================================================
;
;			       mscdex-einsprung
;
;==============================================================================
;
;	>	ax  -  funktionsnummer
;		bx  -  1. parameter
;		cx  -  2. parameter
;
;	<	bx  -  1. ergebnis
;		cx  -  2. ergebnis
;
;------------------------------------------------------------------------------
;
mscdex:
	push	es
	push	ds				;es = ds
	pop	es
	int	MPX				;mscdex aufrufen
	pop	es
	ret
;
;==============================================================================
;
;				adreumrechnung
;
;==============================================================================
;
;	>	dx:ax  -  redbook-adresse
;
;	<	dx:ax  -  frame-adresse
;
;------------------------------------------------------------------------------
;
RedbookToFrame:
	mov	cl,al				;frames retten
	mov	ch,0
	mov	bx,dx				;minuten retten
	mov	al,75				;sekunden -> frames
	mul	ah
	add	cx,ax				;sekunden + frames
	mov	ax,60*75			;minuten -> frames
	mul	bx
	add	ax,cx				;minuten + sekunden + frames
	adc	dx,0
	ret
;
;==============================================================================
;
;	>	dx:ax  -  frame-adresse
;
;	<	al     -  sekunden
;		ah     -  minuten
;
;------------------------------------------------------------------------------
;
FrameToTime:
	call	FrameToRedbook			;ins redbook-format umwandeln
	jmp	RedbookToTime
;
;==============================================================================
;
;	>	dx:ax  -  frame-adresse
;
;	<	dx:ax  -  redbook-adresse
;
;------------------------------------------------------------------------------
;
FrameToRedbook:
	mov	cx,60*75			;minuten extrahieren
	div	cx
	xchg	ax,dx
	mov	cl,75				;sekunden und frames trennen
	div	cl
	xchg	al,ah
	ret
;
;==============================================================================
;
;	>	dx:ax  -  redbook-adresse
;
;	<	al     -  sekunden (bcd)
;		ah     -  minuten  (bcd)
;
;------------------------------------------------------------------------------
;
RedbookToTime:
	cmp	al,(75/2)+1			;frames auswerten
	sbb	al,al
	inc	al
	add	al,ah				;sekunden runden
	mov	ah,dl				;minuten laden
	cmp	al,60				;berlauf?
	jb	RedbookToTime1
	mov	al,0				;bertrag auf die minuten
	inc	ah
RedbookToTime1:
	xchg	al,ah
	call	RedbookToTime2			;binr -> bcd
	xchg	al,ah
RedbookToTime2:
	mov	ch,ah
	mov	ah,0
	mov	cl,10
	div	cl
	mov	cl,4
	shl	al,cl
	or	al,ah
	mov	ah,ch
	ret
;
;==============================================================================
;
;	>	al  -  binrzahl
;
;	<	ax  -  ascii-zahl
;
;------------------------------------------------------------------------------
;
BinaryToAscii:
	mov	ah,0				;100er lschen
	mov	bl,100
	div	bl
	mov	al,ah
	mov	ah,0				;10er und 1er trennen
	mov	bl,10
	div	bl
	add	ax,'00'				;binr -> ascii
	ret
;
;==============================================================================
;
;	>	ax     -  bcd-zahl
;
;	<	dx:ax  -  ascii-zahl
;
;------------------------------------------------------------------------------
;
BcdToAscii:
	mov	cl,4				;bitzhler laden
	mov	bl,ah				;bcd-ziffern trennen
	mov	bh,ah
	shr	bl,cl
	and	bx,0F0Fh
	add	bx,'00'				;binr -> ascii
	mov	dl,al				;bcd-ziffern trennen
	mov	dh,al
	shr	dl,cl
	and	dx,0F0Fh
	add	dx,'00'				;binr -> ascii
	mov	ax,bx
	ret
;
;==============================================================================
;
;				 datensegment
;
;==============================================================================
;
;				  farbpalette
;
;------------------------------------------------------------------------------
;
Palette		equ	$
;
	BYTE	00001010b, 00011011b, 00011000b, 00101110b	;farben a..d
	BYTE	00111110b, 01011110b, 01001100b, 01001111b	;farben e..h
	BYTE	01111111b, 01110000b, 01011110b, 00001010b	;farben i..l
;
;==============================================================================
;
;				 fensterdaten
;
;------------------------------------------------------------------------------
;
MAX_DISPLAY	equ	20
;
;------------------------------------------------------------------------------
;
PosTrackList	BYTE	01, 66, 03, 60
PosPlayStatus	BYTE	22, 09, 22, 19 ,22, 26, 22, 39, 22, 46
;
;------------------------------------------------------------------------------
;
MainWindow		equ	$
;
db 00, 00, 25, 80
db '                                                                                '
db '                                                      Total:               '
db '         01       02       03       04       05           '
db '                                                                        '
db '                                     '
db '                                                                        '
db '         06       07       08       09       10                         '
db '                                                                        '
db '                                     '
db '                                                                        '
db '         11       12       13       14       15                         '
db '                                                                        '
db '                                     '
db '                                                                        '
db '         16       17       18       19       20                         '
db '                                                                        '
db '                                     '
db '                                                                        '
db '         <<       >>      PLAY      II      STOP                        '
db '                                                                        '
db '                                     '
db '                              '
db '                                                                    '
db '                '
db '                 SBS'
db 0
db 'aaabbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbbbbbbbbbbbbbbbbbbbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbiiiiiiiiiiiiiiiicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbbccccccccbbccccccccbbccccccccbbccccccccbbccccccccbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbbccccccccbbccccccccbbccccccccbbccccccccbbccccccccbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbbccccccccbbccccccccbbccccccccbbccccccccbbccccccccbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbddddddddcbddddddddcbddddddddcbddddddddcbddddddddcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbbccccccccbbccccccccbbccccccccbbccccccccbbccccccccbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbeeeeeeeecbeeeeeeeecbffffffffcbffffffffcbffffffffcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbeeeeeeeecbeeeeeeeecbffffffffcbffffffffcbffffffffcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbeeeeeeeecbeeeeeeeecbffffffffcbffffffffcbffffffffcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbbccccccccbbccccccccbbccccccccbbccccccccbbccccccccbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbggggggggcbggggggggggggggggggcbggggggggggggggggggcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbghhhhhhgcbghhhhhhhhhhhhhhhhgcbghhhhhhhhhhhhhhhhgcbbijjjjjjjjjjjjjjicbbbaaa'
db 'aaabbbggggggggcbggggggggggggggggggcbggggggggggggggggggcbbiiiiiiiiiiiiiiiicbbbaaa'
db 'aaabbbbccccccccbbccccccccccccccccccbbccccccccccccccccccbbbccccccccccccccccbbbaaa'
;
;------------------------------------------------------------------------------
;
MouseResetInfo		equ	$
;
db 11, 25, 03, 30
db ''
db '  Initialisierung der Maus  '
db ''
db 0
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
;
;------------------------------------------------------------------------------
;
WaitForDiscInfo		equ	$
;
db 11, 24, 03, 33
db ''
db '  Bitte legen Sie eine CD ein  '
db ''
db 0
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
;
;------------------------------------------------------------------------------
;
GetTrackListInfo	equ	$
;
db 11, 22, 03, 37
db ''
db '  Einlesen der DISC-Informationen  '
db ''
db 0
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
db 'kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkk'
;
;==============================================================================
;
;				 click-tabelle
;
;------------------------------------------------------------------------------
;
ClickList	WORD	InputTable
;
;------------------------------------------------------------------------------
;
InputTable	equ	$
;
	WORD	'01'
	BYTE	01, 06, 03, 08
;
	WORD	'02'
	BYTE	01, 16, 03, 08
;
	WORD	'03'
	BYTE	01, 26, 03, 08
;
	WORD	'04'
	BYTE	01, 36, 03, 08
;
	WORD	'05'
	BYTE	01, 46, 03, 08
;
	WORD	'06'
	BYTE	05, 06, 03, 08
;
	WORD	'07'
	BYTE	05, 16, 03, 08
;
	WORD	'08'
	BYTE	05, 26, 03, 08
;
	WORD	'09'
	BYTE	05, 36, 03, 08
;
	WORD	'10'
	BYTE	05, 46, 03, 08
;
	WORD	'11'
	BYTE	09, 06, 03, 08
;
	WORD	'12'
	BYTE	09, 16, 03, 08
;
	WORD	'13'
	BYTE	09, 26, 03, 08
;
	WORD	'14'
	BYTE	09, 36, 03, 08
;
	WORD	'15'
	BYTE	09, 46, 03, 08
;
	WORD	'16'
	BYTE	13, 06, 03, 08
;
	WORD	'17'
	BYTE	13, 16, 03, 08
;
	WORD	'18'
	BYTE	13, 26, 03, 08
;
	WORD	'19'
	BYTE	13, 36, 03, 08
;
	WORD	'20'
	BYTE	13, 46, 03, 08
;
	WORD	'01'
	BYTE	03, 59, 01, 12
;
	WORD	'02'
	BYTE	04, 59, 01, 12
;
	WORD	'03'
	BYTE	05, 59, 01, 12
;
	WORD	'04'
	BYTE	06, 59, 01, 12
;
	WORD	'05'
	BYTE	07, 59, 01, 12
;
	WORD	'06'
	BYTE	08, 59, 01, 12
;
	WORD	'07'
	BYTE	09, 59, 01, 12
;
	WORD	'08'
	BYTE	10, 59, 01, 12
;
	WORD	'09'
	BYTE	11, 59, 01, 12
;
	WORD	'10'
	BYTE	12, 59, 01, 12
;
	WORD	'11'
	BYTE	13, 59, 01, 12
;
	WORD	'12'
	BYTE	14, 59, 01, 12
;
	WORD	'13'
	BYTE	15, 59, 01, 12
;
	WORD	'14'
	BYTE	16, 59, 01, 12
;
	WORD	'15'
	BYTE	17, 59, 01, 12
;
	WORD	'16'
	BYTE	18, 59, 01, 12
;
	WORD	'17'
	BYTE	19, 59, 01, 12
;
	WORD	'18'
	BYTE	20, 59, 01, 12
;
	WORD	'19'
	BYTE	21, 59, 01, 12
;
	WORD	'20'
	BYTE	22, 59, 01, 12
;
	WORD	'<'
	BYTE	17, 06, 03, 08
;
	WORD	'>'
	BYTE	17, 16, 03, 08
;
	WORD	'P'
	BYTE	17, 26, 03, 08
;
	WORD	'I'
	BYTE	17, 36, 03, 08
;
	WORD	'S'
	BYTE	17, 46, 03, 08
;
	WORD	0, KBD_INVALID
;
;==============================================================================
;
;				kommandotabelle
;
;------------------------------------------------------------------------------
;
CommandList	equ	$
;
	WORD	'<',		PreviousTrack
	WORD	'>',		NextTrack
	WORD	'P',		StartPlay
	WORD	'S',		StopPlay
	WORD	'I',		PausePlay
	WORD	' ',		PausePlay
	WORD	KBD_ENTER,	StartStopPlay
	WORD	KBD_UP,		PreviousTrack
	WORD	KBD_DOWN,	NextTrack
	WORD	KBD_ESCAPE,	0
;
	WORD	KBD_INVALID,	SelectTrack
;
;==============================================================================
;
;			      sonstige variablen
;
;------------------------------------------------------------------------------
;
wVideoSegment		WORD	 0		;videosegment
wWindowLayer		WORD	 0		;fensterebenenzhler
wCursorType		WORD	 0		;cursortyp
wLastCommand		WORD	 KBD_INVALID	;letztes kommando
bInputBuffer		BYTE	 0		;eingabepuffer
bPlayInterrupted	BYTE	 0		;unterbrechungsflag
bPauseMode		BYTE	 0		;pauseflag
;
wMouseType		WORD	 0		;maustyp
wMouseKeys		WORD	 0		;maustastenstatus
bMouseFlag		BYTE	 0		;mauscursor ein/aus
wMouseCursor		WORD	 0		;mauscursoradresse
wMouseData		WORD	 0		;zeichen unter dem mauscursor
;
sDecimalString		BYTE	 "??",0		;puffer fr dezimalanzeige
sDecimalClear		BYTE	 "  ",0		;lscher fr dezimalanzeige
;
sTimeString		BYTE	 "??:??",0	;puffer fr zeitanzeige
sTimeClear		BYTE	 "     ",0	;lscher fr zeitanzeige
;
sTrackString		BYTE	 "?? - ??:??",0	;puffer fr spuranzeige
sTrackClear		BYTE	 "          ",0	;lscher fr spuranzeige
;
;------------------------------------------------------------------------------
;
wStartDevice		WORD	 0
;
wNumberOfDevices	WORD	 0
wDeviceNumber		WORD	 0
wDeviceDrive		WORD	 0
bDeviceSubUnit		BYTE	 0
wDeviceHeaderOffset	WORD	 0
wDeviceHeaderSegment	WORD	 0
sDeviceName		BYTE	 "????????",0
;
sProductCode		BYTE	 "?????????????",0
bNumberOfTracks		BYTE	 0
dNumberOfFrames		DWORD	 0
;
bDeviceBusy		BYTE	 0
bCurrentTrack		BYTE	 0
wNormalTrackTime	WORD	-1
wNormalDiscTime		WORD	-1
wReverseTrackTime	WORD	-1
wReverseDiscTime	WORD	-1
;
;------------------------------------------------------------------------------
;
XX			=	0
;
;------------------------------------------------------------------------------
;
DeviceDrives		equ	$ + XX
;			BYTE	MAX_DEVICES dup (0)
XX			=	XX + (MAX_DEVICES * 1)
;
DeviceEntries		equ	$ + XX
;			DEVICE_ENTRY MAX_DEVICES dup ({})
XX			=	XX + (MAX_DEVICES * SIZE_DEVICE_ENTRY)
;
TrackEntries		equ	$ + XX
;			TRACK_ENTRY MAX_TRACKS dup ({})
XX			=	XX + (MAX_TRACKS * SIZE_TRACK_ENTRY)
;
;------------------------------------------------------------------------------
;
RequestHeader		equ	$ + XX
;			REQUEST_HEADER {}
XX			=	XX + (1 * SIZE_REQUEST_HEADER)
RequestExtension	equ	$ + XX
;			BYTE	SIZE_REQUEST_EXTENSION dup (0)
XX			=	XX + (SIZE_REQUEST_EXTENSION * 1)
;
ControlBlock		equ	$ + XX
;			BYTE	SIZE_CONTROL_BLOCK dup (0)
XX			=	XX + (SIZE_CONTROL_BLOCK * 1)
;
;==============================================================================
;
code	ends
	end	Start
