#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <mouse.h>
#include <graphics.h>
#include <setgmode.h>
#include <zone.h>
#include <math.h>
#include <bios.h>
#include <time.h>

#define MAX_ITER 8

#define COORD_ASSIGN(to,fm) \
    (to).x = (fm).x; (to).y = (fm).y;

#define RAND_DISP (drand(len)-len/2)
#define TRUE  (1)
#define FALSE (0)

#define RAND_MID(to,a,b) \
    (to).x = ((a).x+(b).x)/2 + RAND_DISP; \
    (to).y = ((a).y+(b).y)/2 + RAND_DISP;

typedef enum sub_tri {lf, rt, tp, spn} SUB_TRI;
typedef struct coord_struct { int x,y; } COORD;
typedef struct triang_struct
    {
    struct triang_struct *n, *s, *e, *w, *child;
    COORD top, left, right;
    } TRIANG;

long int len;
unsigned long f;
void *from_cache, *to_cache;
int win_x, win_y;
float mouse_x, mouse_y;
TRIANG *make_triangle (COORD a, COORD b, COORD c);

void main(int argc, char *argv[])
    {
    TRIANG base, *t1, *t2, *t3, *t4, *to_struct_hdr, *from_struct_hdr, *row, *t;
    COORD a,b,c;
    char ch;
    int mb;
    time_t time_buf;
    int mode, iter, done;
    float dev;

    unsigned long int size_per_gen[] =
        { 16384, 16384, 16384, 16384, 16384, 20480, 71232, 264192, 1054672,
          4204496};

    /*
     * See if there is a mouse installed
    if (!mouse_installed())
        {
        printf ("Mouse required for %s\n",argv[0]);
        exit(0);
        }

    reset_mouse();
     */

    dev = 0.0;
    if (argc > 1) dev = atof(argv[1]); else dev = 0.25;
    if (dev == 0.0 || dev > 1.0)
        {
        Usage();
        exit (0);
        }

    srand (time(&time_buf));

    mode = set_graphics_mode (SET_CGA_BW + SET_EGA_BW + SET_VGA_2);

    switch (mode)
        {
        case CGA_BW:
            win_x = 320;
            win_y = 200;
            mouse_x = .5;
            mouse_y = 1;
            break;

        case EGA_BW:
            win_x = 640;
            win_y = 350;
            mouse_x = .5;
            mouse_y = 1;
            break;

        case VGA_2:
            win_x = 640;
            win_y = 480;
            mouse_x = 1;
            mouse_y = 1;
            break;

        default:
            setvmode (DEFAULTMODE);
            printf ("Must have CGA, EGA, or VGA graphics display\n");
            exit(0);
        }

    done = FALSE;
    while (!done)
    {
    clrscrn2(0);
    pen_color (1);

/*    set_mouseposition(win_x/2, win_y/2);
    if (get_mouse_click (&a) == 0) goto cest_finis;
    if (get_mouse_click (&b) == 0) goto cest_finis;
    if (get_mouse_click (&c) == 0) goto cest_finis;
*/
    get_rand_coord (&a,0,win_x,0,win_y/4);
    get_rand_coord (&b,0,win_x/5,win_y*3/4,win_y);
    get_rand_coord (&c,win_x*4/5,win_x,win_y*3/4,win_y);
    to_cache = zinit (512*sizeof(TRIANG), 128*sizeof(TRIANG));
    to_struct_hdr = make_triangle (a,b,c);
    wait (1);
/*
    while (!kbhit() && !mousebuttons());
    if (kbhit()) while (kbhit()) ch = getch();
    if (ch == 'q') goto cest_finis;
    if (ch == 27) continue;
    while (mousebuttons());
*/

    for (iter=0;
         ((iter <= MAX_ITER) && (farcoreleft() > size_per_gen[iter+1]));
         iter++)
        {
        from_cache = to_cache;
        from_struct_hdr = to_struct_hdr;
        to_cache = zinit (512*sizeof(TRIANG), 128*sizeof(TRIANG));
        to_struct_hdr = NULL;

        len = ((long)from_struct_hdr->top.x - (long)from_struct_hdr->left.x)*
              ((long)from_struct_hdr->top.x - (long)from_struct_hdr->left.x)
              +
              ((long)from_struct_hdr->top.y - (long)from_struct_hdr->left.y)*
              ((long)from_struct_hdr->top.y - (long)from_struct_hdr->left.y);
        len = sqrt (len);
        len *= dev;

        clrscrn2(0);
        pen_color (1);

        for (row = from_struct_hdr;
             row != NULL;
             row = row->s)
            {
            for (t = row;
                 t != NULL;
                 t = t->e)
                {
                /* top */
                a = t->top;
                if (t->w != NULL)
                    b = t->w->child->e->right;
                else
                    { RAND_MID (b, t->top, t->left) }
                { RAND_MID (c, t->top, t->right) }
                t1 = make_triangle (a,b,c);

                /* left */
                a = t1->left;
                b = t->left;
                { RAND_MID (c, t->left, t->right) }
                t2 = make_triangle (a,b,c);

                /* right */
                t3 = make_triangle (t1->right, t2->right, t->right);

                /* span */
                if (t->n != NULL)
                    {
                    a = t->n->child->s->right;
                    b = t1->right;
                    { RAND_MID (c, t->e->top, t->e->left) }
                    t4 = make_triangle (a,b,c);
                    }
                else
                    {
                    t4 = NULL;
                    }

                /* link 'em up */
                t->child = t1;

                if (t->w != NULL)
                    {
                    t1->w = t->w->child->e;
                    t->w->child->e->e = t1;
                    t2->w = t->w->child->s->e;
                    t->w->child->s->e->e = t2;
                    }
                else
                    {
                    t1->w = t2->w = NULL;
                    }

                if (t->n != NULL)
                    {
                    t1->n = t->n->child->s;
                    t->n->child->s->s = t1;
                    t4->n = t->n->child->s->e;
                    t->n->child->s->e->s = t4;
                    }
                else
                    {
                    t1->n = NULL;
                    }

                t1->e = t4;
                if (t4) t4->w = t1;
                t2->e = t3;
                t3->w = t2;
                t1->s = t2;
                t2->n = t1;
                if (t4) t4->s = t3;
                t3->n = t4;

                if (to_struct_hdr == NULL) to_struct_hdr = t1;

                }
            }
        /*
         * reset for next gen
         */
        zfree (&from_cache);

        f=farcoreleft();

        if (kbhit())
            ch=getch();
        else
            ch= ' ';

            /*
             * 'q' means we're all done
             */
            if (ch == 'q')
                {
                done = TRUE;
                break;
                }

        wait (1);

        }
    if (!done) wait (5);
    if (kbhit()) if (getch()=='q') done = TRUE;
    zfree (&to_cache);
    }

cest_finis:

    setvmode (DEFAULTMODE);

    }

TRIANG *make_triangle (COORD a, COORD b, COORD c)
    {
    TRIANG *t;

    t = zalloc (to_cache, sizeof (TRIANG));
    t->n = t->s = t->e = t->w = t->child = NULL;
    t->top   = a;
    t->left  = b;
    t->right = c;

    move_to (a.x, a.y);
    line_to (b.x, b.y);
    line_to (c.x, c.y);
    line_to (a.x, a.y);

    return (t);
    }

void wait (int delay)
    {
    time_t start,now;
    for (time(&start),now=start; now-start < delay+1; time(&now));
    }

void get_rand_coord (COORD *pt, int xmin, int xmax, int ymin, int ymax)
    {
    pt->x = drand(xmax - xmin) + xmin;
    pt->y = drand(ymax - ymin) + ymin;
    }

int get_mouse_click (COORD *pt)
    {
    int x,y;
    char ch;

    show_mousecursor();
    while(mousebuttons()==0 && !kbhit());
    if (kbhit()) if ((ch=getch()) == 'q') return (0);
    get_mouseposition(&x, &y);
    do {} while (mousebuttons() != 0);
    hide_mousecursor();

    pt->x = x * mouse_x;
    pt->y = y * mouse_y;

    move_to (pt->x-3, pt->y-3);
    box (6,6,0);
    return (1);
    }

void Usage()
    {
    printf ("Usage: frmesh [ecc]\n");
    printf ("    where\n");
    printf ("    ecc = eccentricity factor (0.0 to 1.0)\n");
    printf ("          (default = .25)\n");
    }
