'----------------------------------------------------------------------------
'    TBOUNCE1 ver 1.0 - cool bouncing triangle
'
'    (c) 1992 Nocturnal Creations - Timothy Truman, David Pastore
'                                                
'    Messing around with line statements one day and they gave
'    birth to this program.                      
'                                                
'    Running speeds will vary with different machines. Use the 'Delay!'
'    variable below to adjust how fast the screen movement is.
'                                                
'                                                
' Ŀ
'   out MATRIX ! An awesome tetris variation written entirely in QB4.5.  
'  Mention this program and take 50% off the current source code price !! 
'  Matrix can be found on Compuserve in the MS BASIC forum under the      
'                       Dos and Mac Basicfile area.                                                                                               
' 
'
'   Questions, suggestions, or rude comments :  
'                                               
'                              AOL - Tim Truman 
'                              AOL - DPast19685 
'                           Compuserve 74734,2203               
'
'                            Nocturnal Creations
'                               P.O. Box 913    
'                           Springfield, MA 01151
'                                               
'----------------------------------------------------------------------------
 
  DECLARE SUB DrawLines ()         ' draw lines in there new postions
  DECLARE SUB Eraselines ()        ' removes old lines
  DECLARE SUB Startvalues ()       ' assigns random values to points
  DECLARE SUB Newpoints ()         ' calculates point movement
  DECLARE SUB Mainloop ()          ' checks for keyboard input , main loop
  DECLARE SUB Cyclemodes ()        ' handles cycling of effects modes
  DECLARE SUB Changecolor ()       ' handles automatic color changing
  DECLARE SUB Selectgrxmode ()     ' displays posible graphics modes , input
  DECLARE SUB Stay ()              ' Delay! routine
  DECLARE SUB Falling ()           ' cool effect
  DECLARE SUB Tips ()              ' read this
 
  COMMON SHARED showmode%
  ' Note : routines that use the variable set below could be condensed
  ' by using arrays. For clarity I have left related routines "expanded".
  COMMON SHARED x1%, oldx1%, Dirx1%, stepx1%
  COMMON SHARED y1%, oldy1%, Diry1%, stepy1%
  COMMON SHARED x2%, oldx2%, Dirx2%, stepx2%
  COMMON SHARED y2%, oldy2%, Diry2%, stepy2%
  COMMON SHARED x3%, oldx3%, Dirx3%, stepx3%
  COMMON SHARED y3%, oldy3%, Diry3%, stepy3%
  COMMON SHARED x4%, oldx4%, Dirx4%, stepx4%
  COMMON SHARED y4%, oldy4%, Diry4%, stepy4%
  COMMON SHARED x5%, oldx5%, Dirx5%, stepx5%
  COMMON SHARED y5%, oldy5%, Diry5%, stepy5%
  COMMON SHARED x6%, oldx6%, Dirx6%, stepx6%
  COMMON SHARED y6%, oldy6%, Diry6%, stepy6%
  
  CONST TRUE = 1
  CONST FALSE = 0
  CONST OfTheUniverse = 42

  '>  Some example values for delay :
     Pentium90 = 4000        ' 512k cache
     sx486at25 = 120         ' no coprocessor
     sx386at16 = 190         ' with math coprocessor
     at286at10 = 30          ' no coprocessor
     xt8088at10 = 0          ' no coprocessor
  '>       
  Delay! = sx386at16         ' set this according to your machine speed
  stepp% = 3                 ' amount point will traverse from last point
  maxstep% = 25              ' maximum point can move
  colorspeed! = 3            ' time in seconds between color changes
  cyclemode% = 0             ' if cycle mode is true, modes 1-5 are cycled
  timepermode% = 15          ' time to view mode in seconds if in cyclemode
  grafxmode% = 9             ' default graphics mode
  MAXx% = 639                ' Max x coordinate assuming screen mode 9
  MAXy% = 339                ' Max y coordinate
  maxcolors% = 16            ' maxcolors for default screen mode
  fgcolor% = 1               ' default color for lines
  bgcolor% = 0               ' default background color
  justgrays% = 0             ' mode 13 effect
  autocolor% = 0             ' all modes check this value

                                  

 DEF fnrnd (num) = INT(RND * num) + 1     '  Function to generate random #s
 RANDOMIZE TIMER                          '  seed the random # generator

 DO                                       '  Front page
 
   CLS
   SCREEN 0: WIDTH 80
   PRINT "TBOUNCE - (c) 1992 Nocturnal Creations"
   PRINT "This program Displays a bouncing Triangle."
   PRINT
   PRINT "During the display Press :             "
   PRINT "A   = to toggle color cycling          G = to toggle Gray Shades (mode 13 only)"
   PRINT "C   = to change color manualy          F = toggle fall  "
   PRINT "D,d = to change Speed of Color Cycle   S,s = adjust step "
   PRINT "+,- = adjust display speed             R = Return to This Screen"
   PRINT
   PRINT "There are different effects that can take place."
   PRINT
   PRINT "Mode 1 - Just Bounces  "
   PRINT "Mode 2 - Leaves 1 Sided Trail  "
   PRINT "Mode 3 - Leaves 2 sided Trail  "
   PRINT "Mode 4 - Two Triangles Bounce"
   PRINT "Mode 5 - Triangles Dual"
   PRINT "Mode 6 - Two Triangles Cool "
   PRINT "Mode 7 - Loop through modes 1 - 6"
   PRINT "Mode 8 - Change Screen Resolution (Default is mode 9)"
   PRINT "Mode 0 - End"
   PRINT
   INPUT "Enter a mode number"; showmode%


   SELECT CASE showmode%

   CASE 0                     ' done
     END

   CASE 7
     cyclemode% = TRUE        ' cycle mode loops through all effects modes
     showmode% = 1            ' start with first one

   CASE 8

     Selectgrxmode            ' choose a graphics mode
  
   END SELECT


   IF showmode% <> 8 THEN   ' If showmode = eight no effectsmode was choosen
     Startvalues
     Mainloop
     cyclemode% = FALSE
   END IF


 LOOP UNTIL showmode% = 0

 SUB Changecolor

 SHARED autocolor%, fgcolor%, maxcolors%, colorspeed!, grafxmode%, justgrays%
 STATIC Time1!
 
 IF autocolor% THEN         ' automatic color cycling
   IF Time1! THEN           ' Got first time sample ? Drop below and get it.
     IF ABS(TIMER - Time1!) > colorspeed! THEN  ' when time has passed
       IF grafxmode% = 13 THEN                     ' treat mode 13 different
         IF justgrays% THEN                      '  mode 13 special effect -
           fgcolor% = fgcolor% + 1
           IF fgcolor% > 30 THEN fgcolor% = 21      ' just use gray colors
         ELSE
           fgcolor% = fgcolor% + 1
           IF fgcolor% > 128 THEN fgcolor% = 17  'colors beyond attr 128 and
         END IF                                'before 17 mess up the effect
       ELSE
         fgcolor% = fgcolor% + 1                 ' increment the color
         IF fgcolor% > maxcolors% - 1 THEN fgcolor% = 1   ' stay legal
       END IF                                 ' color has been incremented so
       Time1! = FALSE                         ' reset time1 for new delay
     END IF
   ELSE
     Time1! = TIMER                 ' sample time for new delay
   END IF


 END IF

END SUB

SUB Cyclemodes
  
 SHARED timepermode%, cyclemode%, showmode%
 STATIC Time1!
 IF cyclemode% THEN                              '
   IF Time1! THEN
     IF ABS(TIMER - Time1!) > timepermode% THEN  ' ABS prevents trouble at
       showmode% = showmode% + 1                  '                  midnight
       IF showmode% > 6 THEN showmode% = 0        ' only six effects modes
       Time1! = FALSE                             ' reset time1 for new value
     END IF
   ELSE
     Time1! = TIMER
   END IF
 END IF

END SUB

SUB DrawLines

 SHARED fgcolor%, showmode%
 
 COLOR fgcolor%

  LINE (x1%, y1%)-(x2%, y2%)            'draw first triangle
  LINE (x2%, y2%)-(x3%, y3%)
  LINE (x1%, y1%)-(x3%, y3%)

 IF showmode% = 4 OR showmode% = 5 THEN
   LINE (x4%, y4%)-(x5%, y5%)           'draw second triangle
   LINE (x5%, y5%)-(x6%, y6%)
   LINE (x4%, y4%)-(x6%, y6%)
 END IF

 IF showmode% = 6 THEN
   LINE (x1%, y1%)-(x4%, y4%), fgcolor% + 1
   LINE (x2%, y2%)-(x5%, y5%), fgcolor% + 1
   LINE (x3%, y3%)-(x6%, y6%), fgcolor% + 1


   LINE (x4%, y4%)-(x5%, y5%)           'draw second triangle
   LINE (x5%, y5%)-(x6%, y6%)
   LINE (x4%, y4%)-(x6%, y6%)

 END IF
 



END SUB

SUB Eraselines

 SHARED showmode%, bgcolor%
 COLOR bgcolor%             ' erase old triangle position to background color

 IF showmode% = 1 THEN                       ' erase entire triangle
   LINE (oldx1%, oldy1%)-(oldx2%, oldy2%)
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)
   LINE (oldx1%, oldy1%)-(oldx3%, oldy3%)
 END IF

 IF showmode% = 2 THEN                       ' erase two sides
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)
   LINE (oldx1%, oldy1%)-(oldx3%, oldy3%)
 END IF

 IF showmode% = 3 THEN
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)    ' erase one side
 END IF

 IF showmode% = 4 THEN                       ' erase all triangles
   LINE (oldx1%, oldy1%)-(oldx2%, oldy2%)
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)
   LINE (oldx1%, oldy1%)-(oldx3%, oldy3%)
   LINE (oldx4%, oldy4%)-(oldx5%, oldy5%)
   LINE (oldx5%, oldy5%)-(oldx6%, oldy6%)
   LINE (oldx4%, oldy4%)-(oldx6%, oldy6%)
 END IF

 IF showmode% = 5 THEN                      ' erase first triangle
   LINE (oldx1%, oldy1%)-(oldx2%, oldy2%)
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)
   LINE (oldx1%, oldy1%)-(oldx3%, oldy3%)
 END IF

 IF showmode% = 6 THEN                      ' erase first triangle
   LINE (oldx1%, oldy1%)-(oldx2%, oldy2%)
   LINE (oldx2%, oldy2%)-(oldx3%, oldy3%)
   LINE (oldx1%, oldy1%)-(oldx3%, oldy3%)
   LINE (oldx4%, oldy4%)-(oldx5%, oldy5%)
   LINE (oldx5%, oldy5%)-(oldx6%, oldy6%)
   LINE (oldx4%, oldy4%)-(oldx6%, oldy6%)

 END IF


END SUB

SUB Falling
  
  SHARED Fall%

  IF Fall% THEN PRINT
       
  
END SUB

SUB Mainloop

  SHARED Delay!, cyclemode%, fgcolor%, maxcolors%, colorspeed!
  SHARED autocolor%, maxstep%, justgrays%, Fall%, stepp%, grafxmode%
   
  SCREEN grafxmode%             ' switch to graphics mode
  
  DO

     kepress$ = INKEY$         ' check for key presses
    
     SELECT CASE kepress$      ' process valid requests
    
     CASE CHR$(13), CHR$(27)   ' return to front page
       kepress$ = "r"
      
     CASE "A", "a"             ' Toggle autocolor
       autocolor% = NOT autocolor%
       IF autocolor% THEN
         LOCATE 1, 1: PRINT "Auto Color On " + SPACE$(23)
       ELSE
         LOCATE 1, 1: PRINT "Auto Color Off   " + SPACE$(22)
       END IF


     CASE "C", "c"                    'increment color value
       fgcolor% = fgcolor% + 1
       IF fgcolor% > maxcolors% - 1 THEN fgcolor% = 1
      
     CASE "-"                         ' decrease program delay (in effect
       Delay! = Delay! - 10           ' increasing display speed)
       LOCATE 1, 1: PRINT "Delay="; Delay!; SPACE$(30)
       IF Delay! < 1 THEN Delay! = 1

     CASE "+"                     ' opposite of above
       Delay! = Delay! + 10
       LOCATE 1, 1: PRINT "Delay="; Delay!; SPACE$(30)
       IF Delay! < 1 THEN Delay! = 1
      
     CASE "S"                         ' decrease point step
       stepp% = stepp% - 1
       IF stepp% < 1 THEN stepp% = 1
       LOCATE 1, 1: PRINT "Step="; stepp%; SPACE$(30)
         
     CASE "s"                         ' increase point step
       stepp% = stepp% + 1
       IF stepp% > maxstep% THEN stepp% = maxstep%
       LOCATE 1, 1: PRINT "Step="; stepp%; SPACE$(30)

     CASE "F", "f"                ' simple but cool effect
       Fall% = NOT Fall%

     CASE "G", "g"                ' gray colors for mode 13
       IF grafxmode% = 13 THEN
         justgrays% = NOT justgrays%
         IF justgrays% = 0 THEN
           LOCATE 1, 1: PRINT "Gray Off" + SPACE$(30)
         ELSE
           LOCATE 1, 1: PRINT "Gray On" + SPACE$(30)
         END IF
       END IF

     CASE "D"                     ' increase the colorcycle delay
       colorspeed! = colorspeed! + .1
       IF colorspeed! > 25 THEN colorspeed! = 25
       LOCATE 1, 1
       PRINT "Colorspeed ";
       PRINT USING "##.##"; colorspeed!;
       PRINT " seconds"
    
     CASE "d"                     ' decrease the color cycle delay
       colorspeed! = ABS(colorspeed! - .1)
       IF colorspeed! < .1 THEN colorspeed! = .1
       LOCATE 1, 1
       PRINT "Colorspeed ";
       PRINT USING "##.##"; colorspeed!;
       PRINT " seconds"
     END SELECT
  
                                  ' make it all happen
     Changecolor
     Eraselines
     DrawLines
     Falling
     Newpoints
     Stay
     Cyclemodes

     COLOR 1                      ' text color
     

  LOOP WHILE (kepress$ <> "r") AND (kepress$ <> "R")

    

END SUB

SUB Newpoints

SHARED stepp%, MAXx%, MAXy%

                        ' save old points so they can be erased
 oldx1% = x1%
 oldy1% = y1%
 oldx2% = x2%
 oldy2% = y2%
 oldx3% = x3%
 oldy3% = y3%
 oldx4% = x4%
 oldy4% = y4%
 oldx5% = x5%
 oldy5% = y5%
 oldx6% = x6%
 oldy6% = y6%
       

       ' create new points relative to direction movement
                  
 IF Dirx1% = 1 THEN                  ' positive direction
   x1% = x1% + stepx1%               ' increment point
   IF x1% > MAXx% THEN               ' bounds check
     Dirx1% = 2                      ' change movement direction
     stepx1% = fnrnd(stepp%)         ' get new step value
   END IF
 ELSE                                ' negative direction
   x1% = x1% - stepx1%               ' decrement point
   IF x1% < 1 THEN                   ' minimum bounds check
     Dirx1% = 1                      ' change movement direction
     stepx1% = fnrnd(stepp%)         ' gives points unpredictable movment
   END IF
 END IF
                                      
                                     ' below does same for rest of points
 IF Diry1% = 1 THEN
   y1% = y1% + stepy1%
   IF y1% > MAXy% THEN
     Diry1% = 2
     stepy1% = fnrnd(stepp%)
   END IF
 ELSE
   y1% = y1% - stepy1%
   IF y1% < 1 THEN
     Diry1% = 1
     stepy1% = fnrnd(stepp%)
   END IF
 END IF

 IF Dirx2% = 1 THEN
   x2% = x2% + stepx2%
   IF x2% > MAXx% THEN
     Dirx2% = 2
     stepx2% = fnrnd(stepp%)
   END IF
 ELSE
   x2% = x2% - stepx2%
   IF x2% < 1 THEN
     Dirx2% = 1
     stepx2% = fnrnd(stepp%)
   END IF
 END IF

 IF Diry2% = 1 THEN
   y2% = y2% + stepy2%
   IF y2% > MAXy% THEN
     Diry2% = 2
     stepy2% = fnrnd(stepp%)
   END IF
 ELSE
   y2% = y2% - stepy2%
   IF y2% < 1 THEN
     Diry2% = 1
     stepy2% = fnrnd(stepp%)
   END IF
 END IF

 IF Dirx3% = 1 THEN
   x3% = x3% + stepx3%
   IF x3% > MAXx% THEN
     Dirx3% = 2
     stepx3% = fnrnd(stepp%)
   END IF
 ELSE
   x3% = x3% - stepx3%
   IF x3% < 1 THEN
     Dirx3% = 1
     stepx3% = fnrnd(stepp%)
   END IF
 END IF

 IF Diry3% = 1 THEN
   y3% = y3% + stepy3%
   IF y3% > MAXy% THEN
     Diry3% = 2
     stepy3% = fnrnd(stepp%)
   END IF
 ELSE
   y3% = y3% - stepy3%
   IF y3% < 1 THEN
     Diry3% = 1
     stepy3% = fnrnd(stepp%)
   END IF
 END IF

 IF Dirx4% = 1 THEN
   x4% = x4% + stepx4%
   IF x4% > MAXx% THEN
     Dirx4% = 2
     stepx4% = fnrnd(stepp%)
   END IF
 ELSE
   IF x4% < 1 THEN
     x4% = x4% - stepx4%
     Dirx4% = 1
     stepx4% = fnrnd(stepp%)
   END IF
 END IF
  
 IF Diry4% = 1 THEN
   y4% = y4% + stepy4%
   IF y4% > MAXy% THEN
     Diry4% = 2
     stepy4% = fnrnd(stepp%)
   END IF
 ELSE
   y4% = y4% - stepy4%
   IF y4% < 1 THEN
     Diry4% = 1
     stepy4% = fnrnd(stepp%)
   END IF
 END IF

 IF Dirx5% = 1 THEN
   x5% = x5% + stepx5%
   IF x5% > MAXx% THEN
     Dirx5% = 2
     stepx5% = fnrnd(stepp%)
   END IF
 ELSE
   x5% = x5% - stepx5%
   IF x5% < 1 THEN
     Dirx5% = 1
     stepx5% = fnrnd(stepp%)
   END IF
 END IF

 IF Diry5% = 1 THEN
   y5% = y5% + stepy5%
   IF y5% > MAXy% THEN
     Diry5% = 2
     stepy5% = fnrnd(stepp%)
   END IF
 ELSE
   y5% = y5% - stepy5%
   IF y5% < 1 THEN
     Diry5% = 1
     stepy5% = fnrnd(stepp%)
   END IF
 END IF

 IF Dirx6% = 1 THEN
   x6% = x6% + stepx6%
   IF x6% > MAXx% THEN
     Dirx6% = 2
     stepx6% = fnrnd(stepp%)
   END IF
 ELSE
   x6% = x6% - stepx6%
   IF x6% < 1 THEN
     Dirx6% = 1
     stepx6% = fnrnd(stepp%)
   END IF
 END IF

 IF Diry6% = 1 THEN
   y6% = y6% + stepy6%
   IF y6% > MAXy% THEN
     Diry6% = 2
     stepy6% = fnrnd(stepp%)
   END IF
 ELSE
   y6% = y6% - stepy6%
   IF y6% < 1 THEN
     Diry6% = 1
     stepy6% = fnrnd(stepp%)
   END IF
 END IF


END SUB

SUB Selectgrxmode

 ' Max screen points and screen colors are set according to choice.
 ' You Cga, Herc and mono users can put your screen mode here. Minor
 ' program modifications will have to be made. See tips routine.


 SHARED maxcolors%, grafxmode%, colorspeed!, stepp%, autocolor%, Delay!
 SHARED MAXx%, MAXy%
 SCREEN 0: WIDTH 80

 DO

    CLS
    PRINT "Here are the Available Resolutions"
    PRINT
    
    
    PRINT "Screen 7   320 X 200  16 colors   Fast"
    PRINT "Screen 8   640 X 200  16 colors   Slower"
    PRINT "Screen 9   640 X 350  16 colors   Slower But Clean "
    PRINT "Screen 10  640 X 350       Mono   Colorless, Blinks"
    PRINT "Screen 12  640 X 480  16 colors   Slowest But Crisp"
    PRINT "Screen 13  320 X 200  256 colors  Fast And Colorful"
    PRINT
    INPUT "Enter The Screen Mode you want >"; grafxmode%


   SELECT CASE grafxmode%
   CASE 0
     grafxmode% = 9
     MAXx% = 639
     MAXy% = 349
     maxcolors% = 16
   CASE 1

     MAXx% = 319
     MAXy% = 199
     maxcolors% = 4
  
   CASE 7
     MAXx% = 319
     MAXy% = 199
     maxcolors% = 16

   CASE 8
     MAXx% = 639
     MAXy% = 199
     maxcolors% = 16

   CASE 9
     MAXx% = 639
     MAXy% = 349
     maxcolors% = 16

   CASE 10
     MAXx% = 639
     MAXy% = 349
     maxcolors% = 4
                       
   CASE 12
     MAXx% = 639
     MAXy% = 479
     maxcolors% = 16

   CASE 13
     MAXx% = 319                    'initialized some extra values here
     MAXy% = 199                    'to show off the colors
     maxcolors% = 256
     colorspeed! = .01              'fast color change
     autocolor% = -1                'cycle through the colors
     Delay! = Delay! + (Delay! / 2) 'compensate for faster grafx operations
     stepp% = 2

   CASE ELSE
     EXIT DO

   END SELECT

 LOOP UNTIL grafxmode%

 END SUB

SUB Startvalues

  SHARED MAXx%, MAXy%

   '  line points, point direction and point step are intialized here.
   '  The random # generator is used so the effect is slighlty different
   '  each time the program is run. It also keeps the max coordinates
   '  in check when switching from a higher resolution to a lower one.
 
  x1% = INT(RND * MAXx%) + 1   ' point coordinates for first triangle are
  y1% = INT(RND * MAXy%) + 1   ' are set to random values between the
  x2% = INT(RND * MAXx%) + 1   ' minumum and maximum screen coordinates
  y2% = INT(RND * MAXy%) + 1
  x3% = INT(RND * MAXx%) + 1
  y3% = INT(RND * MAXy%) + 1

 
  x4% = INT(RND * MAXx%) + 1   ' point locations for second triangle
  y4% = INT(RND * MAXy%) + 1
  x5% = INT(RND * MAXx%) + 1
  y5% = INT(RND * MAXy%) + 1
  x6% = INT(RND * MAXx%) + 1
  y6% = INT(RND * MAXy%) + 1


  Dirx1% = INT(RND * 2) + 1    ' movement direction for first triangle points
  Diry1% = INT(RND * 2) + 1
  Dirx2% = INT(RND * 2) + 1
  Diry2% = INT(RND * 2) + 1
  Dirx3% = INT(RND * 2) + 1
  Diry3% = INT(RND * 2) + 1

 
  Dirx4% = INT(RND * 2) + 1    'movement direction for second triangle points
  Diry4% = INT(RND * 2) + 1
  Dirx5% = INT(RND * 2) + 1
  Diry5% = INT(RND * 2) + 1
  Dirx6% = INT(RND * 2) + 1
  Diry6% = INT(RND * 2) + 1
 

  stepx1% = fnrnd(maxstep%)     'step movement for first triangle  points
  stepy1% = fnrnd(maxstep%)
  stepx2% = fnrnd(maxstep%)
  stepy2% = fnrnd(maxstep%)
  stepx3% = fnrnd(maxstep%)
  stepy3% = fnrnd(maxstep%)

 
  stepx4% = fnrnd(maxstep%)     'step movement for second triangle points
  stepy4% = fnrnd(maxstep%)
  stepx5% = fnrnd(maxstep%)
  stepy5% = fnrnd(maxstep%)
  stepx6% = fnrnd(maxstep%)
  stepy6% = fnrnd(maxstep%)
 

                                'save old points so they can be erased
    oldx1% = x1%
    oldy1% = y1%
    oldx2% = x2%
    oldy2% = y2%
    oldx3% = x3%
    oldy3% = y3%
    oldx4% = x4%
    oldy4% = y4%
    oldx5% = x5%
    oldy5% = y5%
    oldx6% = x6%
    oldy6% = y6%



END SUB

SUB Stay
  SHARED Delay!

  FOR stayhere = 0 TO Delay!: NEXT     ' slow the action down

END SUB

SUB Tips

' Machine speed
' --------------------------------------------------------------------------
'   If your machine isn't listed use the closest one. During the display
'   + or - key to adjust the display speed. When the speed seems
'   right take note of the delay value . Make yourself a variable
'   like "Mymachine" , add it to the list and set it equal to the delay
'   value. Then set your delay! equal to your variable. All set.
'
'   If your machine is an 8088 running under 10Mhz set the "stepp%"
'   higher. This will expand the travel distance between triangle
'   movements. This appears to speed up the display although the
'   animation will become degraded.
'
' Hints
' --------------------------------------------------------------------------
'
'   To create some cool displays may take a little experimenting. Here are
'   a few of my favorites.
'
'    Screen mode 13        Screen mode 12           Screen 9
'    Effects mode 6        Effects mode 5           Effects mode 1
'    Auto color on         Auto color on            Auto color on
'    Gray on               Colorspeed 25 seconds    Colorspeed .40 second
'    Step = 2 or 1         Step = 3                 Step=3
'    Fall off              Fall off                 Fall on
'
'
' Cga and Herc users
' ---------------------------------------------------------------------------
'
'   For CGA (modes1 and 2) and Hercules(mode 3) rem out all the color
'   statements and assign the color attributes to the graphics statements.
'   For example :
'
'   fgcolor% = 1                     fgcolor% = 1
'   Color fgcolor%        to :       ' Color fgcolor%
'   line (a,b)-(c,d)                 line (a,b)-(c,d), fgcolor%
'
'   Near the bottom of the "main loop" routine there is color statement to
'   reset the text color after graphics operations. Remark this out as well.
'   These changes should allow you to use CGA and Herc hardware without
'   any hitches.
'
'   Place your screen mode in the selectgrxmode routine to make it official.
'
'
'
' Could try ...
' --------------------------------------------------------------------------
'  Some modes such as 1 and 9 support background colors. Including
'  the ablity to change the background could make the displays more
'  interesting.
'  -- :)
'
'  Mode 13 system palette sure does get old. Some palette support
'  could liven up those red, green, and blues.
'  -- :)
'
'
'  Filling the triangles - This is harder than you might first think.
'
'  Hint:
'
'                               (1)  Find midpoint of line  AC.
'                  B
'                /   \
'              /       \
'            /           \
'          /               \
'        /                   \
'      A --------------------- C
'                  Z
'
'     Equation to find midpoint of a line segment -   m =  (a + b)/2
'
'     Given  A=0 and C=100 then  Z = (A + C) / 2
'                                Z = (100) / 2
'                                Z = 50
'
'
'                                 (2) Find the midpoint of bisector BZ.
'                  B
'                /  \      
'              /      \
'            /     M     \
'          /              \
'        /                  \
'      A -------------------- C
'                  Z
'
'                                              
'    Armed with this information you could make a routine that finds
'    the near center point of a triangle. Using  M =(a+b)/2  all around
'    is a cheap way out and its not perfect, but it works. After all,
'    thats what counts.
'
'    If you decide to use pages, stay away from clearing the entire
'    screen. Using this solution takes away any effects produced
'    by the different effects modes.
'
'    Keep in mind that the PAINT statement is a time expensive graphics
'    operation. Slower machines may have trouble keeping a good frame rate.
'    So if your using one you may not want to even attempt doing this. Low
'    frame rates ruin the otherwise great effect.
'               _ _
'     Have Fun  @ @
'                o
'
'    --*
'      Rid yourself of the anxitey to see a filled bouncing triangle ,
'      look for TBOUNCE2.BAS.
'    --*
'
'
END SUB

